<?php
//=========eBrowser v2.0.20=========\\
// Author: Emdek                    \\
// URL: http://emdek.cba.pl         \\
// Licence: GPL 2.1 or later        \\
// Updated: 2008-07-20 09:06:52 CET \\
//==================================\\

define ('EBROWSER_VERSION', '2.0.20');
define ('EBROWSER_VERSIONSTATUS','stable');
define ('EBROWSER_VERSIONTIME', 1216537612);

if (!defined ('EBROWSER_PATH')) die ('<em>EBROWSER_PATH</em> is not defined!');
error_reporting (E_ALL);
set_magic_quotes_runtime (0);
$ERRORS = '';
$ECounter = 0;
function e_error_handler ($ENo, $EString, $EFile, $ELine) {
	if (strstr ($EString, 'Please use the date.timezone setting')) return;
	$GLOBALS['ERRORS'].= '<strong>'.$EFile.': <em>'.$ELine.'</em></strong> '.$EString.'<br />
';
	++$GLOBALS['ECounter'];
	}
set_error_handler ('e_error_handler');
session_start ();
$Start = array_sum (explode (' ', microtime ()));
$Theme = $Information = $LocationArray = array ();
$Theme['information'] = $Theme['locationbar'] = $Theme['announcements'] = $Theme['windows'] = $Theme['statusbar'] = $Theme['sidebar-bookmarks'] = $Theme['sidebar-tags'] = $Theme['sidebar-history'] = $Theme['sidebar-trash'] = $Theme['sidebar-ftp'] = $Page = $SelectLocale = $SelectTheme = '';
$Theme['sidebar-active'] = 'information';
$AllSize = $DirectoriesAmount = $FilesAmount = $DB = 0;
$TabIndex = 50;
$DirName = dirname ($_SERVER['SCRIPT_NAME']);
if ($DirName != '/') $DirName.= '/';
$BrowserPath = realpath (EBROWSER_PATH);
require (EBROWSER_PATH.'lib/functions.php');
include (EBROWSER_PATH.'conf/config.php');
if (!defined ('eBrowser')) include (EBROWSER_PATH.'conf/default.php');
if (e_cookie_get ('language')) $_SESSION['eBrowser']['language'] = e_cookie_get ('language');
if (isset ($_GET['language'])) $_SESSION['eBrowser']['language'] = $_GET['language'];
if (isset ($_POST['language'])) {
   $_SESSION['eBrowser']['language'] = &$_POST['language'];
   e_cookie_set ('language', $_POST['language']);
   }
$Locales = glob (EBROWSER_PATH.'locale/*', GLOB_ONLYDIR);
for ($i = 0, $c = count ($Locales); $i < $c; ++$i) $Locales[$i] = basename ($Locales[$i]);
if (!isset ($_SESSION['eBrowser']['language'])) {
   if (isset ($_SERVER['HTTP_ACCEPT_LANGUAGE']) && $_SERVER['HTTP_ACCEPT_LANGUAGE']) {
      $String = strtolower ($_SERVER['HTTP_ACCEPT_LANGUAGE']);
      $Language = (substr ($String, 0, (strlen ($String) > 2 && $String[2] == '-')?5:2));
      }
   else $Language = '';
   $_SESSION['eBrowser']['language'] = (in_array ($Language, $Locales)?$Language:(in_array (substr ($Language, 0, 2), $Locales)?substr ($Language, 0, 2):'en'));
   }
if (e_cookie_get ('theme')) $_SESSION['eBrowser']['theme'] = e_cookie_get ('theme');
if (isset ($_GET['theme'])) $_SESSION['eBrowser']['theme'] = $_GET['theme'];
if (isset ($_POST['theme'])) {
   $_SESSION['eBrowser']['theme'] = $_POST['theme'];
   e_cookie_set ('theme', $_POST['theme']);
   }
if (!isset ($_SESSION['eBrowser']['theme']) || !is_file (EBROWSER_PATH.'share/themes/'.$_SESSION['eBrowser']['theme'].'/theme.tpl')) $_SESSION['eBrowser']['theme'] = 'Gray';
$ThemeConfiguration = parse_ini_file (EBROWSER_PATH.'share/themes/'.$_SESSION['eBrowser']['theme'].'/theme.ini');
if ($ThemeConfiguration['FixedView']) $_COOKIE['eBrowserView'] = &$ThemeConfiguration['FixedView'];
$Theme['icontheme'] = &$ThemeConfiguration['Icons'];
$Theme['updatesidebar'] = &$ThemeConfiguration['UpdateSidebar'];
$Themes = glob (EBROWSER_PATH.'share/themes/*', GLOB_ONLYDIR);
for ($i = 0, $c = count ($Themes); $i < $c; ++$i) {
    $Name = basename ($Themes[$i]);
    if (is_file ($Themes[$i].'/theme.ini') && $Name != 'common') {
       $TmpArray = parse_ini_file ($Themes[$i].'/theme.ini');
       $SelectTheme.= '<option value="'.urlencode ($Name).'"'.(($Name == $_SESSION['eBrowser']['theme'])?' selected="selected"':'').'>'.htmlspecialchars ($TmpArray['Name']).'</option>
';
       }
    }
if (!isset ($_SESSION['eBrowser']['language']) || !is_readable (EBROWSER_PATH.'locale/'.$_SESSION['eBrowser']['language'].'/locale.php')) $_SESSION['eBrowser']['language'] = 'en';
for ($i = 0, $c = count ($Locales); $i < $c; ++$i) {
    $TmpArray = parse_ini_file (EBROWSER_PATH.'locale/'.$Locales[$i].'/locale.ini');
    $LocaleName[$Locales[$i]] = $TmpArray['Name'];
    if ($Locales[$i] == $_SESSION['eBrowser']['language']) {
       $Theme['dir'] = $TmpArray['Dir'];
       $Locale = explode ('|', $TmpArray['Locale']);
       }
    $SelectLocale.= '<option value="'.$Locales[$i].'"'.(($Locales[$i] == $_SESSION['eBrowser']['language'])?' selected="selected"':'').'>'.$LocaleName[$Locales[$i]].'</option>
';
    }
setlocale (LC_ALL, $Locale);
putenv ('LANG='.$_SESSION['eBrowser']['language']);
putenv ('LANGUAGE='.$_SESSION['eBrowser']['language']);
e_locale_load ($_SESSION['eBrowser']['language']);
if (!defined ('eBrowser')) {
   $AdminPassword = substr (md5 ($Start), 26);
   $_SESSION['eBrowser']['password'] = md5 ($AdminPassword);
   $UniqueID = md5 (uniqid (mt_rand (0, 1000000000)));
   if (file_put_contents (EBROWSER_PATH.'conf/config.php', '<?php
$UniqueID = \''.$UniqueID.'\';
$RatingsTable = 0;
$DataBase = 0;
$AdminPassword = \''.$_SESSION['eBrowser']['password'].'\';
$DetailedColumns = array (\'name\', \'size\', \'type\', \'time\', \'rating\');
$DefaultTheme = \'Gray\';
$DataDir = \'data/\';
$ThumbnailSourceSize = 204800;
$PathPrefix = \''.basename ($_SERVER['SCRIPT_NAME']).'?path=\';
$PathSeparator = \'&amp;\';
$PathSuffix = \'\';
$History = 0;
define (\'eBrowser\', '.$_SERVER['REQUEST_TIME'].');
define (\'eBrowserBoard\', 1);
?>')) {
      copy (EBROWSER_PATH.'data/data.sqlite', EBROWSER_PATH.'data/data_'.$UniqueID.'.sqlite');
      $Information[] = array (e_i18n ('Configuration saved successful.'), 'success');
      $Information[] = array (sprintf (e_i18n ('New administrator password is %s.'), '<em>'.$AdminPassword.'</em>'), 'information');
      }
   else $Information[] = array (e_i18n ('An error occured during configuration saving!'), 'error');
   include (EBROWSER_PATH.'conf/config.php');
   }
if (!defined ('eBrowser')) $Information[] = array (e_i18n ('Cannot load configuration file!'), 'error');
e_cookie_set ('cookie', 1);
$Theme['prefix'] = $PathPrefix;
$Theme['separator'] = $PathSeparator;
$Theme['suffix'] = $PathSuffix;
$Theme['dirname'] = $DirName;
$Theme['datapath'] = $DirName.EBROWSER_PATH;
$Theme['path'] = $DirName.$PathPrefix;
$Theme['self'] = htmlspecialchars ($_SERVER['REQUEST_URI']);
$Views = array ('detailed', 'tree', 'icons');
$Columns = array ('name', 'size', 'type', 'time', 'access', 'permissions', 'owner', 'views', 'comments', 'rating');
if (isset ($_GET['path'])) $Path = $_GET['path'];
else $Path = (isset ($_SERVER['PATH_INFO'])?$_SERVER[((!$_SERVER['PATH_INFO'] && isset ($_SERVER['ORIG_PATH_INFO']))?'ORIG_':'').'PATH_INFO']:'');
if (!$Path) $Path = '/';
else $Path = str_replace ('../', '', urldecode ($Path));
if ($Path && $Path[0] == '.') $Path = substr ($Path, 1);
if (isset ($_POST['ftphost']) && $_POST['ftphost'] && $_POST['ftplogin']) {
   $_SESSION['eBrowser']['ftp'][$_POST['ftplogin'].'@'.$_POST['ftphost']] = array (
	'port' => (int) $_POST['ftpport'],
	'password' => $_POST['ftppassword']
	);
   $Path = $_POST['ftplogin'].'@'.$_POST['ftphost'].':'.$_POST['ftpport'].($_POST['ftpstart']?$_POST['ftpstart']:'/');
   if (isset ($_POST['ftpremember'])) {
      if (e_cookie_get ('ftp')) $FTP = e_cookie_get ('ftp');
      else $FTP = array ();
      if (!in_array ($Path, $FTP)) $FTP[] = $Path;
      e_cookie_set ('ftp', $FTP);
      }
   $Path = 'ftp:'.$Path;
   }
if (isset ($_POST['address'])) die (header ('Location: '.$Theme['path'].$_POST['address']));
if (isset ($_GET['view']) && in_array ($_GET['view'], $Views)) {
   $_COOKIE['eBrowserView'] = $_GET['view'];
   setcookie ('eBrowserView', $_GET['view'], ($_SERVER['REQUEST_TIME'] + 31536000));
   }
if (isset ($_GET['preview'])) {
   $_COOKIE['eBrowserPreview'] = !$_COOKIE['eBrowserPreview'];
   setcookie ('eBrowserPreview', (int) $_COOKIE['eBrowserPreview'], ($_SERVER['REQUEST_TIME'] + 31536000));
   }
if (isset ($_REQUEST['sort']) && in_array ($_REQUEST['sort'], $Columns)) {
   $_COOKIE['eBrowserSortBy'] = $_REQUEST['sort'];
   setcookie ('eBrowserSortBy', $_REQUEST['sort'], ($_SERVER['REQUEST_TIME'] + 31536000));
   }
if (isset ($_REQUEST['direction']) && is_numeric ($_REQUEST['direction'])) {
   $_COOKIE['eBrowserSortDirection'] = $_REQUEST['direction'];
   setcookie ('eBrowserSortDirection', $_REQUEST['direction'], ($_SERVER['REQUEST_TIME'] + 31536000));
   }
if (isset ($_POST['sortform'])) {
   $_COOKIE['eBrowserSeparate'] = (int) isset ($_POST['separatefiles']);
   setcookie ('eBrowserSeparate', (int) isset ($_POST['separatefiles']), ($_SERVER['REQUEST_TIME'] + 31536000));
   }
if (!isset ($_COOKIE['eBrowserView']) || !in_array ($_COOKIE['eBrowserView'], $Views)) $_COOKIE['eBrowserView'] = 'icons';
if (!isset ($_COOKIE['eBrowserPreview'])) $_COOKIE['eBrowserPreview'] = 1;
if (!isset ($_COOKIE['eBrowserSortBy']) || !in_array ($_COOKIE['eBrowserSortBy'], $Columns)) $_COOKIE['eBrowserSortBy'] = 'name';
if (!isset ($_COOKIE['eBrowserSortDirection']) || !is_numeric ($_COOKIE['eBrowserSortDirection'])) $_COOKIE['eBrowserSortDirection'] = 1;
if (!isset ($_COOKIE['eBrowserSeparate'])) $_COOKIE['eBrowserSeparate'] = 1;
if ((!isset ($_SESSION['eBrowser']['password']) || !$_SESSION['eBrowser']['password']) && e_cookie_get ('password')) {
   if (e_cookie_get ('password') == md5 ($AdminPassword.$UniqueID)) $_SESSION['eBrowser']['password'] = $AdminPassword;
   if (isset ($_SESSION['eBrowser']['password'])) e_cookie_set ('password', md5 ($_SESSION['eBrowser']['password'].$UniqueID));
   }
if (isset ($_POST['Password']) && !isset ($_POST['area'])) {
   $_SESSION['eBrowser']['password'] = md5 ($_POST['Password']);
   if (isset ($_POST['Remember'])) e_cookie_set ('password', md5 ($_SESSION['eBrowser']['password'].$UniqueID));
   }
if (isset ($_GET['logout']) && !$_GET['logout']) {
   if (isset ($_SESSION['eBrowser']['password'])) unset ($_SESSION['eBrowser']['password']);
   e_cookie_set ('password', 0);
   die (header ('Location: '.$_SERVER['PHP_SELF']));
   }
if (defined ('eBrowserBoard') && eBrowserBoard && isset ($_SESSION['eBrowser']['password']) && $_SESSION['eBrowser']['password'] == $AdminPassword) define ('EBROWSER_ADMIN', 1);
if ($DataBase && include (EBROWSER_PATH.'lib/database.class.php')) {
   try {
       $DB = new ebrowser_database ();
       }
   catch (Exception $e) {
         $DB = 0;
         }
   }
if (!is_file (EBROWSER_PATH.'share/themes/'.$_SESSION['eBrowser']['theme'].'/theme.tpl')) die (e_i18n ('Could not load theme!'));
$File = file_get_contents (EBROWSER_PATH.'share/themes/'.$_SESSION['eBrowser']['theme'].'/theme.tpl');
preg_match_all ('#\[start:(.*?)\](.*?)\[/end\]#si', $File, $Blocks);
for ($i = 0, $c = count ($Blocks[0]); $i < $c; ++$i) $Theme[$Blocks[1][$i]] = $Blocks[2][$i];
unset ($File, $Blocks);
$Theme['lang_loading'] = e_i18n ('Loading...');
$Theme['lang_ebrowser'] = e_i18n ('File browser');
$Theme['lang_close'] = e_i18n ('Close');
$Theme['lang_information'] = e_i18n ('Information');
$Theme['lang_logout'] = e_i18n ('Logout');
$Theme['lang_backward'] = e_i18n ('Backward');
$Theme['lang_dirup'] = e_i18n ('Directory up');
$Theme['lang_forward'] = e_i18n ('Forward');
$Theme['lang_refresh'] = e_i18n ('Refresh');
$Theme['lang_maindir'] = e_i18n ('Main directory');
$Theme['lang_viewdetailed'] = e_i18n ('Detailed view');
$Theme['lang_viewtree'] = e_i18n ('Tree view');
$Theme['lang_viewicons'] = e_i18n ('Icons view');
$Theme['lang_preview'] = e_i18n ('Preview');
$Theme['lang_sorting'] = e_i18n ('Sorting');
$Theme['lang_filtering'] = e_i18n ('Filtering');
$Theme['lang_search'] = e_i18n ('Search');
$Theme['lang_login'] = e_i18n ('Login');
$Theme['lang_clean'] = e_i18n ('Clean');
$Theme['lang_configuration'] = e_i18n ('Configuration');
$Theme['lang_about'] = e_i18n ('About eBrowser...');
$Theme['lang_iewarning'] = e_i18n ('You can have problems with using full capabilities of eBrowser using Internet Explorer!');
$Theme['lang_nojs'] = e_i18n ('If You want to use full capabilities of eBrowser You should have JavaScript enabled!');
$Theme['lang_query'] = e_i18n ('Query');
$Theme['lang_searchregexp'] = e_i18n ('Use regular exspression (example: #.*#i)');
$Theme['lang_onlythisdir'] = e_i18n ('Only current directory');
$Theme['lang_ftp'] = e_i18n ('FTP');
$Theme['lang_trash'] = e_i18n ('Trash');
$Theme['lang_bookmarks'] = e_i18n ('Bookmarks');
$Theme['lang_tags'] = e_i18n ('Tags');
$Theme['lang_history'] = e_i18n ('History');
$Theme['lang_location'] = e_i18n ('Location');
$Theme['lang_gototop'] = e_i18n ('Go to top');
$Theme['lang_thumbnails'] = e_i18n ('Thumbnails');
$Theme['lang_first'] = e_i18n ('First');
$Theme['lang_previous'] = e_i18n ('Previous');
$Theme['lang_startpause'] = e_i18n ('Start / pause');
$Theme['lang_stop'] = e_i18n ('Stop');
$Theme['lang_next'] = e_i18n ('Next');
$Theme['lang_last'] = e_i18n ('Last');
$Theme['lang_actions'] = e_i18n ('Actions');
$Theme['lang_rating'] = e_i18n ('Rating');
$Theme['lang_tags'] = e_i18n ('Tags');
$Theme['lang_signature'] = e_i18n ('Signature');
$Theme['lang_address'] = e_i18n ('Address');
$Theme['lang_active'] = e_i18n ('Active');
$Theme['lang_confirmimage'] = e_i18n ('Transcribe text form the picture');
$Theme['lang_increasefield'] = e_i18n ('Increase edit field');
$Theme['lang_decreasefield'] = e_i18n ('Decrease edit field');
$Theme['lang_save'] = e_i18n ('Save');
$Emoticons = array (
	':-)' => 'smile',
	';-)' => 'wink',
	':-D' => 'happy',
	'lol' => 'lol',
	':-P' => 'razz',
	':-|' => 'neutral',
	':-(' => 'sad',
	';-(' => 'cry',
	'oops' => 'embarassed',
	'shock' => 'shock',
	':-?' => 'confused',
	'sleep' => 'sleep',
	);
$BBCode = array (
	'URL' => e_i18n ('[URL]link[/URL] or [URL=&quot;link&quot;]name[/URL]'),
	'B' => e_i18n ('[B]bold text[/B]'),
	'I' => e_i18n ('[I]italic text[/I]'),
	'U' => e_i18n ('[U]underlined text[/U]'),
	'P' => e_i18n ('[P]paragraph[/P]'),
	'QUOTE' => e_i18n ('[QUOTE]quote[/QUOTE] or [QUOTE=&quot;author&quot;]quote[/QUOTE]'),
	'CODE' => e_i18n ('[CODE]code[/CODE]')
	);
$LocaleFileTypes = array (
	'directory' => e_i18n ('Directory'),
	'backup' => e_i18n ('Backup'),
	'html' => e_i18n ('HTML document'),
	'xml' => e_i18n ('Document'),
	'text' => e_i18n ('Text file'),
	'archive' => e_i18n ('Archive'),
	'video' => e_i18n ('Video'),
	'audio' => e_i18n ('Sound'),
	'image' => e_i18n ('Image'),
	'source' => e_i18n ('Source file'),
	'document' => e_i18n ('Document'),
	'spreadsheet' => e_i18n ('Spreadsheet'),
	'presentation' => e_i18n ('Presentation'),
	'font' => e_i18n ('Font file'),
	'svg' => e_i18n ('Vector graphics'),
	'cdimage' => e_i18n ('CD image'),
	'pdf' => e_i18n ('PDF document'),
	'exe' => e_i18n ('Executable file'),
	'swf' => e_i18n ('Flash animation'),
	'url' => e_i18n ('Link'),
	'shell' => e_i18n ('Shell script'),
	'database' => e_i18n ('Database'),
	'unknown' => e_i18n ('Unknown')
	);
$LocaleColumns = array (
	'name' => e_i18n ('Name'),
	'size' => e_i18n ('Size'),
	'type' => e_i18n ('Type'),
	'time' => e_i18n ('Modification'),
	'access' => e_i18n ('Access'),
	'permissions' => e_i18n ('Permissions'),
	'owner' => e_i18n ('Owner'),
	'views' => e_i18n ('Views'),
	'rating' => e_i18n ('Rating'),
	'comments' => e_i18n ('Comments'),
	'trash' => e_i18n ('Deleted')
	);
if (isset ($_GET['request'])) {
   error_reporting (0);
   if (!isset ($_GET['thumbnail'])) header ('Content-type: application/x-javascript');
   require (EBROWSER_PATH.'lib/requests.class.php');
   if (isset ($_GET['window'])) ebrowser_requests::window ();
   if (isset ($_GET['sidebar'])) ebrowser_requests::sidebar ();
   if (isset ($_GET['slideshow'])) ebrowser_requests::slideshow ();
   if (isset ($_GET['rating'])) ebrowser_requests::rating ();
   if (isset ($_GET['ftp']) && isset ($_SESSION['eBrowser']['ftp'])) ebrowser_requests::ftp ();
   if (isset ($_GET['thumbnail'])) ebrowser_requests::thumbnail ();
   if (isset ($_GET['locations'])) ebrowser_requests::locations ();
   if (isset ($_GET['bookmarks'])) ebrowser_requests::bookmarks ();
   if (isset ($_GET['actions'])) ebrowser_requests::actions ();
   if (isset ($_GET['search']) && $_GET['search']) ebrowser_requests::search ();
   if (isset ($_GET['confirm'])) ebrowser_requests::confirm ();
   if (isset ($_GET['contents'])) ebrowser_requests::contents ();
   if (defined ('EBROWSER_ADMIN')) {
      if (isset ($_GET['size'])) ebrowser_requests::size ();
      if (isset ($_GET['archives'])) ebrowser_requests::archives ();
      }
   if (!isset ($_GET['show'])) die ('showLoading (0);');
   }
if (defined ('EBROWSER_ADMIN')) {
   if (isset ($_POST['CurrentPassword']) || isset ($_POST['DefaultTheme'])) {
      $Status = 1;
      if (isset ($_POST['CurrentPassword'])) {
         if (md5 ($_POST['CurrentPassword']) == $AdminPassword && $_POST['NewPassword'] == $_POST['RepeatPassword']) {
            $AdminPassword = $_SESSION['eBrowser']['password'] = md5 ($_POST['NewPassword']);
            if (e_cookie_get ('password')) e_cookie_set ('password', md5 ($_SESSION['eBrowser']['password'].$UniqueID));
            }
         else {
              if (md5 ($_POST['CurrentPassword']) !== $AdminPassword) {
                 $_SESSION['eBrowser']['password'] = '';
                 die (header ('Location: ?logout'));
                 }
              else {
                   $Information[] = array (e_i18n ('Given passwords are diffrent!'), 'error');
                   $Status = 0;
                   }
              }
         }
      else {
           $DetailedColumns = array_intersect ($_POST['DetailedColumns'], $Columns);
           $Array = array ('DataDir', 'DefaultTheme', 'ThumbnailSourceSize', 'PathPrefix', 'PathSeparator', 'PathSuffix', 'History');
           for ($i = 0, $c = count ($Array); $i < $c; ++$i) $$Array[$i] = $_POST[$Array[$i]];
           }
      if ($Status) {
         $Status = file_put_contents (EBROWSER_PATH.'conf/config.php', '<?php
$UniqueID = \''.$UniqueID.'\';
$DataBase = '.(int) $DataBase.';
$RatingsTable = '.(int) $RatingsTable.';
$AdminPassword = \''.$AdminPassword.'\';
$DetailedColumns = array (\''.implode ('\', \'', $DetailedColumns).'\');
$DefaultTheme = \''.(is_file (EBROWSER_PATH.'share/themes/'.$DefaultTheme.'/theme.ini')?str_replace ('\'', '\\\'', $DefaultTheme):'Gray').'\';
$DataDir = \''.str_replace ('\'', '\\\'', $DataDir).'\';
$ThumbnailSourceSize = '.(int) $ThumbnailSourceSize.';
$PathPrefix = \''.str_replace ('\'', '\\\'', $PathPrefix).'\';
$PathSeparator = \''.str_replace ('\'', '\\\'', $PathSeparator).'\';
$PathSuffix = \''.str_replace ('\'', '\\\'', $PathSuffix).'\';
$History = '.(int) $History.';
define (\'eBrowser\', '.(int) eBrowser.');
define (\'eBrowserBoard\', 1);
?>');
         $Information[] = array (($Status?e_i18n ('Configuration saved successful.'):e_i18n ('An error occured during configuration saving!')), ($Status?'success':'error'));
         }
      }
   if (isset ($_GET['trash']) && $DB) {
      $FileSystem = e_file_system_model ('trash:/');
      if (isset ($_GET['move'])) {
         $DB->location_update (urldecode ($_GET['move']), array ('trash' => $_SERVER['REQUEST_TIME']));
         $FileSystem->refresh ();
         $Information[] = array (e_i18n ('Element moved to Trash successful.'), 'success');
         }
      if (isset ($_GET['retrieve']) && $FileSystem->exists (urldecode ($_GET['retrieve']))) {
         $DB->location_update (urldecode ($_GET['retrieve']), array ('trash' => 0));
         $FileSystem->refresh ();
         $Information[] = array (e_i18n ('Element retrieved from Trash successful.'), 'success');
         }
      if (isset ($_GET['empty'])) {
         $Status = 1;
         $Entries = $FileSystem->entries ();
         for ($i = 0, $c = count ($Entries); $i < $c; ++$i) {
             if ($FileSystem->delete ($Entries[$i])) $DB->location_update ($Entries[$i]);
             else $Status = 0;
             $FileSystem->refresh ();
             }
         $Information[] = array (($Status?e_i18n ('Trash emptied successful.'):e_i18n ('An error occured during emptying Trash!')), ($Status?'success':'error'));
         }
      }
   if (isset ($_POST['entrydelete'])) {
      $Path = urldecode ($_POST['entrydelete']);
      $FileSystem = e_file_system_model ($Path);
      if (method_exists ($FileSystem, 'delete')) {
         $Status = $FileSystem->delete ($Path);
         if ($Status && $DB) {
            $DB->location_update ($Path);
            $Path = e_path_parent ($Path);
            }
         $FileSystem->refresh ();
         $Information[] = array (($Status?e_i18n ('Element deleted successful.'):e_i18n ('An error occured during deleting element!')), ($Status?'success':'error'));
         }
      }
   if (isset ($_POST['copy'])) {
      $FileSystem = e_file_system_model ($_POST['copy']);
      $Status = $FileSystem->copy ($Path, $_POST['copy']);
      if ($Status) $DB->location_update ($_POST['copy'], e_location_array ($Path));
      $FileSystem->refresh ();
      $Information[] = array (($Status?e_i18n ('Element copied successful.'):e_i18n ('An error occured during copying element!')), ($Status?'success':'error'));
      }
   if (isset ($_POST['symlink']) && method_exists ($FileSystem, 'symlink')) {
      $FileSystem = e_file_system_model ($_POST['symlink']);
      $Status = $FileSystem->symlink ($Path, $_POST['symlink']);
      if ($Status && $DB && $DB->location_exists ($Path)) $DB->location_update ($_POST['symlink'], e_location_array ($Path));
      $FileSystem->refresh ();
      $Information[] = array (($Status?e_i18n ('Link created successful.'):e_i18n ('An error occured during creating link!')), ($Status?'success':'error'));
      }
   if (isset ($_POST['save'])) {
      $FileSystem = e_file_system_model ($Path);
      $Status = 1;
      if ($DB) $DB->location_update ($Path, array (
	'description' => $_POST['description'],
	'icon' => $_POST['icon'],
	'locked' => isset ($_POST['locked']),
	'password' => (($_POST['password'] && $_POST['password'] == $_POST['repeatpassword'])?md5 ($_POST['password']):''),
	'area' => (($_POST['password'] && $_POST['password'] == $_POST['repeatpassword'])?md5 ($Path):''),
	'hidden' => isset ($_POST['hidden']),
	'hidesource' => isset ($_POST['hidesource']),
	'preview' => isset ($_POST['preview']),
	'comments' => isset ($_POST['comments']),
	'ratings' => isset ($_POST['ratings']),
	'counters' => isset ($_POST['counters']),
	));
      if (isset ($_POST['chmod']) && method_exists ($FileSystem, 'chmod') && !$FileSystem->chmod ($Path, octdec ($_POST['chmod']))) $Status = 0;
      if (isset ($_POST['name']) && basename ($Path) !== $_POST['name']) {
         $NewPath = e_path_parent ($Path).'/'.$_POST['name'];
         if (!$FileSystem->rename ($Path, $NewPath)) $Status = 0;
         if ($Status && $DB && $DB->location_exists ($Path)) {
            $DB->location_update ($Path, array ('path' => $NewPath));
            $Path = &$NewPath;
            }
         }
      if (isset ($_POST['contents'])) {
         if (isset ($_POST['encoding']) && function_exists ('mb_convert_encoding')) $_POST['contents'] = mb_convert_encoding ($_POST['contents'], $_POST['encoding'], 'UTF-8');
         if (!$FileSystem->save ($Path, $_POST['contents'])) $Status = 0;
         }
      $FileSystem->refresh ();
      $Information[] = array (($Status?e_i18n ('Element saved successful.'):e_i18n ('An error occured during saving element!')), ($Status?'success':'error'));
      }
   if (isset ($_POST['delete']) && $DB) {
      $FileSystem = e_file_system_model ($Path);
      $DB->location_update ($Path);
      $FileSystem->refresh ();
      }
   if (isset ($_POST['create']) && $_POST['create']) {
      $FileSystem = e_file_system_model ($Path);
      $Status = $FileSystem->create ($Path.$_POST['create'], isset ($_POST['directory']));
      $FileSystem->refresh ();
      $Information[] = array (($Status?e_i18n ('Element created successful.'):e_i18n ('An error occured during creating element!')), ($Status?'success':'error'));
      }
   if (isset ($_POST['renamepattern']) && $_POST['renamepattern']) {
      $Amount = 0;
      $FileSystem = e_file_system_model ($Path);
      $Entries = $FileSystem->entries ($Path);
      for ($i = 0, $c = count ($Entries); $i < $c; ++$i) {
          $Name = basename ($Entries[$i]);
          $NewName = preg_replace ($_POST['renamepattern'], $_POST['renamereplacement'], $Name);
          if ($Name != $NewName && !$FileSystem->exists ($Path.$NewName) && $FileSystem->rename ($Entries[$i], $Path.$NewName)) {
             $DB->location_update (substr ($Entries[$i], 1), array ('path' => $Path.$NewName));
             ++$Amount;
             }
          }
      $FileSystem->refresh ();
      $Information[] = array (sprintf (e_i18n ('%s renamed elements.'), '<em>'.$Amount.'</em>'), 'information');
      }
   if (isset ($_POST['uploadsize']) && $DB) {
      $Array = array ();
      for ($i = 0, $c = count ($_POST['uploadsize']); $i < $c; ++$i) $Array[$i] = array ($_POST['uploadsize'][$i], $_POST['uploadtype'][$i], $_POST['uploadpattern'][$i]);
      $DB->upload_update ($Path, $Array);
      }
   if (isset ($_POST['tags']) && $DB) {
      $DB->tags_update ($Path, explode (', ', $_POST['tags']));
      $Information[] = array (e_i18n ('Tags updated successful.'), 'success');
      }
   if (isset ($_GET['clean'])) {
      $Files = glob (EBROWSER_PATH.$DataDir.'thumbnails/*');
      for ($i = 0, $c = count ($Files); $i < $c; ++$i) unlink ($Files[$i]);
      if ($DB) $DB->clean ();
      $Information[] = array (e_i18n ('Cleaning finished successful.'), 'success');
      }
   }
if (isset ($_FILES['uploadfile']) && $_FILES['uploadfile']['name']) {
   $FileType = e_file_type ($Extension, $_FILES['uploadfile']['type']);
   $Possible = 0;
   if (!defined ('EBROWSER_ADMIN') && $Array = e_upload_array ($Path)) {
      $FileName = basename ($_FILES['uploadfile']['name']);
      for ($i = 0, $c = count ($Array); $i < $c; ++$i) {
          if ((!$Array[$i]['size'] || $_FILES['uploadfile']['size'] < $Array[$i]['size']) && (!$Array[$i]['pattern'] || preg_match ($Array[$i]['pattern'], $FileName)) && (!$Array[$i]['type'] || strtoupper ($Array[$i]['type']) == $FileType[0])) {
             $Possible = 1;
             break;
             }
          }
      }
   if (is_uploaded_file ($_FILES['uploadfile']['tmp_name']) && (defined ('EBROWSER_ADMIN') || ($DB && $Possible))) {
      if (is_file ($Path.$_FILES['uploadfile']['name']) && defined ('EBROWSER_ADMIN') && isset ($_POST['overwrite'])) unlink ($Path.$_FILES['uploadfile']['name']);
      $Status = move_uploaded_file ($_FILES['uploadfile']['tmp_name'], '.'.$Path.$_FILES['uploadfile']['name']);
      }
   else $Status = 0;
   $FileSystem->refresh ();
   $Information[] = array (($Status?e_i18n ('Element send successful.'):e_i18n ('An error occured during sending element!')), ($Status?'success':'error'));
   }
if (isset ($_FILES['bookmarksimport']) && is_uploaded_file ($_FILES['bookmarksimport']['tmp_name'])) {
   $Array = file ($_FILES['bookmarksimport']['tmp_name']);
   if (e_cookie_get ('bookmarks')) $Bookmarks = e_cookie_get ('bookmarks');
   else $Bookmarks = array ();
   for ($i = 0, $c = count ($Array); $i < $c; ++$i) {
       if (!strstr ($Array[$i], chr (30))) continue;
       $TmpArray = explode (chr (30), trim ($Array[$i], "\r\n"));
       $Bookmarks[$TmpArray[0]] = &$TmpArray[1];
       }
   setcookie (md5 ($UniqueID.'bookmarks'), serialize ($Bookmarks), ($_SERVER['REQUEST_TIME'] + 31536000), $DirName);
   unset ($Array);
   $Information[] = array (e_i18n ('Bookmarks imported successful.'), 'success');
   }
$FileSystem = e_file_system_model ($Path);
if (!$FileSystem->exists ($Path)) {
   if ($Type = $FileSystem->type () == 'ftp') $Information[] = array (e_i18n ('Cannot connect to FTP!'), 'error');
   else if ($Type = $FileSystem->type () == 'archive') $Information[] = array (e_i18n ('Cannot open archive file!'), 'error');
   $Path = '/';
   $FileSystem = e_file_system_model ('/');
   }
$FileSystemInformation = $FileSystem->information ($Path);
if (!$FileSystem->exists ($Path) || !e_permissions ($FileSystemInformation, $FileSystem)) {
   $Page = '';
   $Information[] = array (e_i18n ('Wrong access path!'), 'error');
   $FileSystemInformation['directory'] = 0;
   }
else {
      if ($DB) {
         if ((!isset ($_SESSION['eBrowser'][$FileSystemInformation['area']]) || !$_SESSION['eBrowser'][$FileSystemInformation['area']]) && e_cookie_get ('pass-'.$FileSystemInformation['area'])) {
            if (e_cookie_get ('pass-'.$FileSystemInformation['area']) == md5 ($FileSystemInformation['password'].$UniqueID)) $_SESSION['eBrowser'][$FileSystemInformation['area']] = $FileSystemInformation['password'];
            if (isset ($_SESSION['eBrowser'][$FileSystemInformation['area']])) e_cookie_set ('pass-'.$FileSystemInformation['area'], md5 ($FileSystemInformation['password'].$UniqueID));
            }
         if (isset ($_POST['Password']) && isset ($_POST['area'])) {
            $_SESSION['eBrowser'][$_POST['area']] = md5 ($_POST['Password']);
            if (isset ($_POST['Remember'])) e_cookie_set ('pass-'.$_POST['area'], md5 ($_SESSION['eBrowser'][$_POST['area']].$UniqueID));
            }
         if (isset ($_GET['logout']) && $_GET['logout']) {
            if (isset ($_SESSION['eBrowser'][$_GET['logout']])) unset ($_SESSION['eBrowser'][$_GET['logout']]);
            e_cookie_set ('pass-'.$_GET['logout'], 0);
            die (header ('Location: '.$_SERVER['PHP_SELF']));
            }
        if (isset ($_SESSION['eBrowser'][$FileSystemInformation['area']]) && $FileSystemInformation['password'] == $_SESSION['eBrowser'][$FileSystemInformation['area']]) define ('EBROWSER_AREA', 1);
        if (isset ($_GET['commentactivate']) && defined ('EBROWSER_ADMIN')) $DB->comments_update ($Path, $_GET['commentactivate'], array ('active' => 1));
        if (isset ($_GET['commentdelete']) && defined ('EBROWSER_ADMIN')) $DB->comments_update ($Path, $_GET['commentdelete']);
        if (isset ($_POST['commentcontent']) && $_POST['commentcontent'] && $_POST['commentauthor'] && $FileSystemInformation['comments']) {
           if (defined ('EBROWSER_ADMIN') || ((!function_exists ('gd_info') || (strtoupper ($_SESSION['eBrowser']['confirm']) == strtoupper ($_POST['confirm']))) && (!isset ($_SESSION['eBrowser']['comments']) || ($_SERVER['REQUEST_TIME'] - $_SESSION['eBrowser']['comments']) > 30))) {
              $_SESSION['eBrowser']['comments'] = $_SERVER['REQUEST_TIME'];
              e_cookie_set ('author', $_POST['commentauthor']);
              e_cookie_set ('url', $_POST['commenturl']);
              $DB->comments_update ($Path, ((defined ('EBROWSER_ADMIN') && isset ($_POST['commentid']))?$_POST['commentid']:$_SERVER['REQUEST_TIME']), array (
	'ip' => htmlspecialchars ($_SERVER['REMOTE_ADDR']),
	'useragent' => htmlspecialchars ($_SERVER['HTTP_USER_AGENT']),
	'author' => htmlspecialchars ($_POST['commentauthor']),
	'url' => htmlspecialchars ($_POST['commenturl']),
	'content' => (defined ('EBROWSER_ADMIN')?$_POST['commentcontent']:htmlspecialchars ($_POST['commentcontent'])),
	'active' => (int) (isset ($_POST['commentid'])?(isset ($_POST['commentactive']) && defined ('EBROWSER_ADMIN')):defined ('EBROWSER_ADMIN'))
	));
              $Information[] = array (e_i18n ('Comment saved successful.'), 'success');
              }
           else $Information[] = array (e_i18n ('Comment can not be saved!'), 'error');
           }
        }
     if ($DB && $FileSystemInformation['locked'] && !defined ('EBROWSER_ADMIN') && !defined ('EBROWSER_AREA')) $Information[] = array (e_i18n ('Access denied!'), 'error').e_announce ('<a href="{path}'.$Path.'{separator}request&amp;window=login&amp;area='.$FileSystemInformation['area'].'" tabindex="'.(++$TabIndex).'">'.e_i18n ('Login').'</a>.', 'information');
     else {
          if ($DB && $FileSystem->type () != 'trash') {
             if ($FileSystemInformation['counters']) $DB->views_update ($Path);
             if (isset ($_GET['rating']) && $FileSystemInformation['ratings']) {
                if ($DB->rating_update ($Path, (int) $_GET['rating'])) $Information[] = array (e_i18n ('Rating was added.'), 'success');
                }
             }
          if ($DB && $History) $DB->history_update ($Path);
          if (!$FileSystemInformation['browseable']) {
             if ($FileSystem->type () == 'local' && $FileSystemInformation['type'] == 'archive') {
                $Prefix = '';
                if ($FileSystemInformation['extension'] == 'BZ2' && function_exists ('bzopen')) $Prefix = 'compress.bzip2://';
                else if ($FileSystemInformation['extension'] == 'GZ' && function_exists ('gzopen')) $Prefix = 'compress.zlib://';
                else $Information[] = array (e_i18n ('Cannot open archive file!'), 'error');
                if ($Prefix) {
                   $Contents = file_get_contents ($Prefix.substr ($Path, 1));
                   $Extension = explode ('.', $FileSystemInformation['name']);
                   $FileSystemInformation['extension'] = strtoupper ($Extension[count ($Extension) - 2]);
                   }
                }
             else if ($FileSystem-> type () != 'trash') $Contents = $FileSystem->contents ($Path);
             if (function_exists ('finfo_buffer') && $Contents !== NULL) {
                $FileInfo = finfo_open (FILEINFO_NONE);
                $MIMEDescription = finfo_buffer ($FileInfo, $Contents);
                finfo_close ($FileInfo);
                $FileInfo = finfo_open (FILEINFO_MIME);
                $MIME = finfo_buffer ($FileInfo, $Contents);
                $FileSystemInformation['mime'] = $MIMEDescription.' ('.$MIME.')';
                finfo_close ($FileInfo);
                $FileType = e_file_type ($FileSystemInformation['extension'], $FileSystemInformation['mime']);
                $FileSystemInformation['icon'] = e_icon_path ($FileType[0]);
                $FileSystemInformation['information'] =  $LocaleFileTypes[$FileType[0]].(isset ($FileType[1])?' ('.$FileType[1].')':'');
                $FileSystemInformation['type'] = $FileType[0];
                }
             $FileSystemInformation['binary'] = (($Contents !== NULL)?strstr ($Contents, "\x00"):0);
             if ($FileSystemInformation['type'] == 'image') $Page.= '<div id="filepreview">
<img src="{path}&amp;request&amp;contents='.urlencode ($Path).'" alt="'.e_i18n ('Preview').'" id="filepreview_image" onclick="imageResize (\'filepreview\')" onload="ResizeMode = 1; imageResize (\'filepreview\');" />
</div>
';
             else if ($FileSystemInformation['type'] == 'svg' || $FileSystemInformation['type'] == 'video') $Page.= '<div id="filepreview">
<object data="{path}&amp;request&amp;contents='.urlencode ($Path).'">
'.e_announce (e_i18n ('Preview unavailable.'), 'infomation').'</object>
</div>
';
             else if ($FileSystemInformation['type'] == 'swf') {
                     $Page.= '<div id="filepreview">
<object data="{path}&amp;request&amp;contents='.urlencode ($Path).'" type="application/x-shockwave-flash">
'.e_announce (e_i18n ('Preview unavailable.'), 'infomation').'</object>
<param name="movie" value="{path}&amp;request&amp;contents='.urlencode ($Path).'" />
<param name="quality" value="high" />
</object>
</div>
';
                     }
             else if ($FileSystemInformation['type'] == 'font' && file_exists (EBROWSER_PATH.$DataDir.'thumbnails/'.md5 ($Path).'.png')) $Page.= '<div id="filepreview">
<img src="{path}{separator}request&amp;thumbnail='.urlencode ($Path).'" alt="'.e_i18n ('Preview').'" />
</div>
';
             else if ((defined ('EBROWSER_ADMIN') || !$DB || !$FileSystemInformation['hidesource']) && !$FileSystemInformation['binary'] && $FileSystemInformation['size']) {
                     if ($FileSystemInformation['readable']) {
                        if (!isset ($Contents)) $Contents = $FileSystem->contents ($Path);
                        if (function_exists ('mb_convert_encoding')) {
                           $Encodings = mb_list_encodings ();
                           natcasesort ($Encodings);
                           $Encoding = ((isset ($_GET['encoding']) && in_array (urldecode ($_GET['encoding']), $Encodings))?urldecode ($_GET['encoding']):mb_detect_encoding ($Contents));
                           $SelectEncodings = '';
                           for ($i = 0, $c = count ($Encodings); $i < $c; ++$i) $SelectEncodings.= '<option'.(($Encoding == $Encodings[$i])?' selected="selected"':'').'>'.$Encodings[$i].'</option>
';
                           $Page.= '<form action="{self}" method="get">
'.(isset ($_GET['path'])?'<div>
<input type="hidden" name="path" value="'.htmlspecialchars ($_GET['path']).'" />
</div>
':'').'<p>
<span>
<select name="encoding" id="encoding" tabindex="'.(++$TabIndex).'">
'.$SelectEncodings.'</select>
<input type="submit" value="'.e_i18n ('Change').'" tabindex="'.(++$TabIndex).'" class="button" />
</span>
<label for="encoding">'.e_i18n ('Characters encoding').'</label>:
</p>
</form>
';
                           $Contents = mb_convert_encoding ($Contents, 'UTF-8', $Encoding);
                           }
                        if ($ThemeConfiguration['SimpleSourcePreview']) $Page.= htmlspecialchars ($Contents);
                        else $Page.= e_file_colorize ($Contents);
                        }
                     else $Information[] = array (e_i18n ('Unreadable!'), 'error');
                     }
             else $Page.= e_announce (e_i18n ('Preview unavailable.'), 'infomation');
             if (isset ($_GET['edit']) && defined ('EBROWSER_ADMIN')) {
                if ($FileSystemInformation['binary']) $Information[] = array (e_i18n ('File is binary.'), 'warning');
                if ($FileSystemInformation['size'] >= 1000000) $Information[] = array (e_i18n ('File is too big for content edit!'), 'error');
                if ($FileSystemInformation['writeable'] && $FileSystemInformation['size'] < 1000000) {
                   $Contents = $FileSystem->contents ($Path);
                   if (function_exists ('mb_convert_encoding')) {
                      $Encoding = (isset ($_GET['encoding'])?urldecode ($_GET['encoding']):mb_detect_encoding ($Contents));
                      $Contents = mb_convert_encoding ($Contents, 'UTF-8', $Encoding);
                      }
                   }
                }
             }
          else {
               if ($_COOKIE['eBrowserView'] == 'detailed') {
                  $SortBar = '';
                  if ($FileSystem->type () == 'trash') $DetailedColumns = array ('name', 'size', 'type', 'time', 'trash');
                  for ($i = 0, $c = count ($DetailedColumns); $i < $c; ++$i) {
                      if (($DetailedColumns[$i] == 'time' && $FileSystem->type () == 'tags' && $Path == 'tags:/') || ($DetailedColumns[$i] == 'rating' && !$FileSystemInformation['ratings']) || ($DetailedColumns[$i] == 'views' && !$FileSystemInformation['counters']) || ($DetailedColumns[$i] == 'comments' && !$FileSystemInformation['comments'])) {
                         $DetailedColumns = array_merge (array_slice ($DetailedColumns, 0, $i), array_slice ($DetailedColumns, ($i + 1)));
                         --$i;
                         --$c;
                         continue;
                         }
                      $Direction = (int) (($_COOKIE['eBrowserSortBy'] == $DetailedColumns[$i])?!$_COOKIE['eBrowserSortDirection']:1);
                      $Sort = '<a href="{self}{separator}sort='.$DetailedColumns[$i].'&amp;direction='.$Direction.'" tabindex="'.(++$TabIndex).'">
'.(($_COOKIE['eBrowserSortBy'] == $DetailedColumns[$i])?'<strong>'.($_COOKIE['eBrowserSortDirection']?'ˆ':'ˇ').'</strong>
':'').$LocaleColumns[$DetailedColumns[$i]].'
</a>
';
                      $SortBar.= '<th'.(($DetailedColumns[$i] == 'name')?' class="name"':'').($ThemeConfiguration['JavaScript']?' onclick="location.href=\'{self}{separator}sort='.$DetailedColumns[$i].'&amp;direction='.$Direction.'\'"':'').' title="'.($Direction?e_i18n ('Sort ascending'):e_i18n ('Sort descending')).'">
'.$Sort.'</th>
';
                      }
                  $Page.= '<table cellpadding="0" cellspacing="0" id="entries" style="width:100%;min-width:'.(($c + 1) * 120).'px;">
<tr id="sortbar">
'.$SortBar.'</tr>
';
                  }
               else $Page.= '<div id="entries">
';
               if ($_COOKIE['eBrowserView'] == 'tree') {
                  $LocalPath = $Path.'/';
                  $MainDirectory = $FileSystem->prefix ().'/';
                  $End = 0;
                  while (!$End) {
                        if ($LocalPath == $MainDirectory) $End = 1;
                           $Entries = e_entries ($LocalPath);
                           $TreeBranch = ($Entries?implode ('', $Entries):'');
                           $TreePath = $LocalPath;
                           $LocalPath = e_path_parent ($LocalPath);
                           }
                  if ($FileSystem->type () == 'archive') $MainFileSystem = e_file_system_model ('/');
                  else $MainFileSystem = &$FileSystem;
                  $MainInformation = $MainFileSystem->information ($MainDirectory);
                  $Emblems = e_entry_emblems ($FileSystemInformation, $FileSystem);
                  $Thumbnail = '';
                  $Summary = e_entry_summary ($FileSystemInformation, $FileSystem, $Thumbnail, $Emblems);
                  $Page.= '<ul>
<li>
<div id="entry_34403cd13ba8314730006f8645a178e6" class="entry" onclick="entrySelect (\'34403cd13ba8314730006f8645a178e6\')" onmouseover="tooltipDelay (\'tooltip_34403cd13ba8314730006f8645a178e6\', 1)" onmouseout="tooltipDelay (\'tooltip_34403cd13ba8314730006f8645a178e6\', 0)">
<img src="'.$MainInformation['icon'].'" alt="'.$MainFileSystem->type ().'" title="'.e_i18n ('Show / hide').'" id="tree_34403cd13ba8314730006f8645a178e6_icon" onclick="directoryShowHide (\'/\', \'tree_34403cd13ba8314730006f8645a178e6\');" />
<a href="{path}'.$MainDirectory.'">
'.$MainInformation['name'].'
</a>
<script type="text/javascript">
EntriesAmount++;
Entries[\'34403cd13ba8314730006f8645a178e6\'] = new Object;
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'number\'] = EntryNumber++;
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'path\'] = \''.$MainInformation['path'].'\';
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'name\'] = \''.$MainInformation['name'].'\';
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'extension\'] = \''.$MainInformation['extension'].'\';
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'type\'] =  \''.$MainInformation['type'].'\';
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'time\'] = \''.date ('d M Y H:i:s', $MainInformation['time']).'\';
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'size\'] = '.(int) $MainInformation['size'].';
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'link\'] = '.(int) $MainInformation['link'].';
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'hidden\'] = '.(int) $MainInformation['hidden'].';
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'locked\'] = '.(int) $MainInformation['locked'].';
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'broken\'] = '.(int) $MainInformation['broken'].';
Entries[\'34403cd13ba8314730006f8645a178e6\'][\'trash\'] = '.(int) ($MainInformation['trash'] && $FileSystem->type () != 'trash').';
</script>
<div class="tooltip" id="tooltip_34403cd13ba8314730006f8645a178e6" style="display:none;">
'.$Summary.'</div>
</div>
<ul id="tree_34403cd13ba8314730006f8645a178e6">
'.$TreeBranch.'</ul>
</li>
</ul>
';
                  }
               else {
                    if ($Entries = e_entries ($Path)) $Page.= implode ('', $Entries);
                    else {
                         if ($FileSystem->type () == 'trash' || $FileSystemInformation['readable']) $Information[] = array (e_i18n ('No entries.'), 'information');
                         else $Information[] = array (e_i18n ('Unreadable!'), 'error');
                         }
                    }
               if ($_COOKIE['eBrowserView'] == 'detailed') $Page.= '</table>
';
               else $Page.= '</div>
';
               }
          $Theme['up'] = $Theme['path'].e_path_parent ($Path);
          if ($FileSystem->type () == 'local' && $_COOKIE['eBrowserPreview']) $Thumbnail = e_entry_thumbnail ($FileSystemInformation, $FileSystem);
          else $Thumbnail = '';
          if ($FileSystemInformation['ratings'] && !$FileSystemInformation['trash']) $Rating = e_rating_widget ($FileSystemInformation['path'], $FileSystemInformation['ratingsamount'], $FileSystemInformation['rating']);
          else $Rating = '';
          $Tags = ($DB?e_tags_widget ($FileSystemInformation['path']):'');
          $Emblems = e_entry_emblems ($FileSystemInformation, $FileSystem);
          $Theme['information'] = e_theme_switches (e_theme_parse ($GLOBALS['Theme']['information'], array (
	'information' => e_entry_summary ($FileSystemInformation, $FileSystem, $Thumbnail, $Emblems),
	'actions' => (($Actions = e_entry_actions ($FileSystemInformation, $FileSystem))?'<ol class="actions">
'.$Actions.'</ol>
':''),
	'tags' => &$Tags,
	'ratings' => &$Rating
	)), array ('ratings' => ($FileSystemInformation['ratings'] && !$FileSystemInformation['trash']), 'tags' => strlen ($Tags)));
          if (!$FileSystem->type () != 'trash') {
             $Theme['statusbar'] = (($_COOKIE['eBrowserView'] == 'tree')?'':'<div id="statusbar">
'.(($FileSystemInformation['directory'] || $FileSystemInformation['browseable'])?sprintf (e_i18n ('Directories: %d, files: %d (%s)'), $DirectoriesAmount, $FilesAmount, e_size ($AllSize)):sprintf (e_i18n ('%s, size: %s'), $FileSystemInformation['information'], e_size ($FileSystemInformation['size']))).'
</div>
');
             }
          if (isset ($_GET['edit']) && defined ('EBROWSER_ADMIN')) {
             if (!$FileSystemInformation['writeable']) $Information[] = array (e_i18n ('Unwriteable.'), 'warning');
             $Page.= '<form action="{self}" method="post">
<h3>
'.e_i18n ('Settings').'
</h3>
'.($FileSystemInformation['writeable']?'<p>
<span>
<input name="name" value="'.htmlspecialchars ($FileSystemInformation['name']).'" id="name" tabindex="'.(++$TabIndex).'" />
</span>
<label for="name">'.e_i18n ('Name').'</label>:
</p>
<p>
<span>
<input name="chmod" value="'.substr (decoct ($FileSystemInformation['permissions']), 2).'" id="chmod" tabindex="'.(++$TabIndex).'" />
</span>
<label for="chmod">'.e_i18n ('Permissions').'</label>:
</p>
':'').($DB?'<p style="height:50px;">
<span>
<textarea name="description" id="description" rows="3" cols="50" tabindex="'.(++$TabIndex).'" style="width:400px;">'.htmlspecialchars ($FileSystemInformation['description']).'</textarea>
</span>
<label for="description">'.e_i18n ('Description').'</label>:
</p>
<p>
<span>
<img src="'.$FileSystemInformation['icon'].'" alt="preview" id="iconselector_preview" />
<input name="icon" id="iconselector_input" />
<input type="button" value="'.e_i18n ('Select').'" class="button" onclick="windowShowHide (\'iconselector\')" />
</span>
<label for="iconselector_input">'.e_i18n ('Icon').'</label>:
</p>
'.($FileSystemInformation['directory']?e_announce (e_i18n ('Following settings will be also used as default in subdirectories!'), 'warning'):'').'<p>
<span>
<input type="checkbox" name="locked" value="1" id="locked"'.($FileSystemInformation['locked']?' checked="checked"':'').' tabindex="'.(++$TabIndex).'" />
</span>
<label for="locked">'.e_i18n ('Locked').'</label>:
</p>
<p>
<span>
<input type="password" name="password" id="password" tabindex="'.(++$TabIndex).'" />
</span>
<label for="password">'.e_i18n ('Access password').($FileSystemInformation['password']?' <strong>['.e_i18n ('Currently set').']</strong>':'').'</label>:
</p>
<p>
<span>
<input type="password" name="repeatpassword" id="repeatpassword" tabindex="'.(++$TabIndex).'" />
</span>
<label for="repeatpassword">'.e_i18n ('Repeat password').'</label>:
</p>
'.($FileSystemInformation['directory']?'<p>
<span>
<input type="checkbox" name="hidden" value="1" id="hidden" tabindex="'.(++$TabIndex).'" />
</span>
<label for="hidden">'.e_i18n ('Hide').'</label>:
</p>
<p>
<span>
<input type="checkbox" name="hidesource" value="1" id="hidesource" tabindex="'.(++$TabIndex).'" />
</span>
<label for="hidesource">'.e_i18n ('Turn off source preview').'</label>:
</p>
<p>
<span>
<input type="checkbox" name="preview" value="1" id="preview"'.($FileSystemInformation['preview']?' checked="checked"':'').' tabindex="'.(++$TabIndex).'" />
</span>
<label for="preview">'.e_i18n ('Thumbnails').'</label>:
</p>
':'').'<p>
<span>
<input type="checkbox" name="counters" value="1" id="counters"'.($FileSystemInformation['counters']?' checked="checked"':'').' tabindex="'.(++$TabIndex).'" />
</span>
<label for="counters">'.e_i18n ('Views counters').'</label>:
</p>
<p>
<span>
<input type="checkbox" name="ratings" value="1" id="ratings"'.($FileSystemInformation['ratings']?' checked="checked"':'').' tabindex="'.(++$TabIndex).'" />
</span>
<label for="ratings">'.e_i18n ('Ratings').'</label>:
</p>
<p>
<span>
<input type="checkbox" name="comments" value="1" id="comments"'.($FileSystemInformation['comments']?' checked="checked"':'').' tabindex="'.(++$TabIndex).'" />
</span>
<label for="comments">'.e_i18n ('Comments').'</label>:
</p>
</p>
':'').((!$FileSystemInformation['directory'] && $FileSystemInformation['writeable'])?'<h3>
<input type="button" value="&#9660;" title="'.e_i18n ('Increase edit field').'" onclick="document.getElementById(\'filecontents\').rows += 5" class="button" style="float:left;" tabindex="'.(++$TabIndex).'" />
<label for="filecontents">'.e_i18n ('File contents').'</label>
<input type="button" value="&#9650;" title="'.e_i18n ('Decrease edit field').'" onclick="document.getElementById(\'filecontents\').rows -= 5" class="button" style="float:right;" tabindex="'.(++$TabIndex).'" />
</h3>
<textarea rows="'.(substr_count ($Contents, "\n") + 5).'" cols="100" name="contents" id="filecontents" tabindex="'.(++$TabIndex).'">'.htmlspecialchars ($Contents).'</textarea>
'.(function_exists ('mb_convert_encoding')?'<p>
<span>
<select name="encoding" id="fileencoding" tabindex="'.(++$TabIndex).'">
'.$SelectEncodings.'</select>
</span>
<label for="fileencoding">'.e_i18n ('Characters encoding').'</label>:
</p>
':''):'').'<div class="buttons">
<input type="submit" name="save" value="'.e_i18n ('Save').'" tabindex="'.(++$TabIndex).'" class="button" />
<input type="submit" name="delete" value="'.e_i18n ('Delete').'" tabindex="'.(++$TabIndex).'" class="button" />
<input type="reset" value="'.e_i18n ('Reset').'" tabindex="'.(++$TabIndex).'" class="button" />
</div>
</form>
';
             if ($FileSystemInformation['directory'] && $FileSystemInformation['writeable'] && $DB) {
                $FileTypes = array ('html', 'xml', 'text', 'archive', 'video', 'audio', 'image', 'source', 'document', 'spreadsheet', 'presentation', 'font', 'svg', 'cdimage', 'pdf', 'exe', 'swf', 'shell', 'database');
                $Amount = count ($FileTypes);
                $Page.= '<form action="{self}" method="post">
<h3>
'.e_i18n ('File upload rules').'
</h3>
<table cellspacing="0" cellpadding="0" id="uploadrules">
<tr>
<th>
'.e_i18n ('Max size (B) (0 - no limit)').'
</th>
<th>
'.e_i18n ('Type').'
</th>
<th>
'.e_i18n ('Name pattern (example /.*/si)').'
</th>
</tr>
';
                $Array = $DB->upload_array ($FileSystemInformation['path']);
                for ($i = 0, $c = count ($Array); $i <= $c; ++$i) {
                    $Page.= '<tr>
<td>
<input name="uploadsize[]" value="'.(($i == $c)?'':$Array[$i]['size']).'" tabindex="'.(++$TabIndex).'" />
</td>
<td>
<select name="uploadtype[]" tabindex="'.(++$TabIndex).'">
<option></option>
';
                    for ($j = 0; $j < $Amount; ++$j) $Page.= '<option value="'.strtoupper ($FileTypes[$j]).'"'.(($i != $c && strtoupper ($FileTypes[$j]) == $Array[$i]['type'])?' selected="selected"':'').'>'.$LocaleFileTypes[$FileTypes[$j]].'</option>
';
                    $Page.= '</select>
</td>
<td>
<input name="uploadpattern[]" value="'.(($i == $c)?'':$Array[$i]['pattern']).'" tabindex="'.(++$TabIndex).'" />
</td>
</tr>
';
                    }
                $Page.= '</table>
<div class="buttons">
<input type="submit" value="'.e_i18n ('Save').'" class="button" />
</div>
</form>
';
                }
             }
          if (isset ($_GET['comments']) && $FileSystemInformation['comments'] && $DB) {
             $Page.= '<h3 id="comments">
'.e_i18n ('Comments').'
</h3>
';
             $Array = $DB->comments_array ($FileSystemInformation['path'], 0, (isset ($_GET['page'])?$_GET['page']:0));
             for ($i = 0, $c = count ($Array); $i < $c; ++$i) {
                 $Page.= e_theme_parse ($Theme['comment'], array (
	'author' => ($Array[$i]['url']?'<a href="'.htmlspecialchars ($Array[$i]['url']).'" tabindex="'.(++$TabIndex).'">'.htmlspecialchars ($Array[$i]['author']).'</a>':htmlspecialchars ($Array[$i]['author'])),
	'content' => e_text_format (htmlspecialchars ($Array[$i]['content'])),
	'information' => (defined ('EBROWSER_ADMIN')?'<div>
'.e_i18n ('IP').': <em>'.htmlspecialchars ($Array[$i]['ip']).'</em> |
'.e_i18n ('User Agent').': <em>'.htmlspecialchars ($Array[$i]['useragent']).'</em> |
<a href="{path}{separator}comments&amp;commentedit='.$Array[$i]['time'].'#commentform" tabindex="'.(++$TabIndex).'">'.e_i18n ('Edit').'</a> |
<a href="{path}{separator}comments&amp;commentdelete='.$Array[$i]['time'].'" tabindex="'.(++$TabIndex).'">'.e_i18n ('Delete').'</a> |
'.($Array[$i]['active']?'':'<a href="{path}{separator}comments&amp;commentactivate='.$Array[$i]['time'].'" style="color:red;" tabindex="'.(++$TabIndex).'">'.e_i18n ('Activate').'</a> |
').'</div>
':''),
	'id' => $Array[$i]['time'],
	'date' => date ('Y.m.d H:i:s', $Array[$i]['time']),
	));
                 }
             if (($Amount = $DB->comments_amount ($Path)) > 10) $Page.= e_links (((!isset ($_GET['page']) || $_GET['page'] < 1 || $_GET['page'] > ($Amount / 10))?ceil ($Amount / 10):$_GET['page']), ceil ($Amount / 10), '{path}'.$Path.'{separator}comments&amp;page={page}');
             $BBCodeList = $EmoticonsList = '';
             foreach ($BBCode as $Key => $Value) $BBCodeList.= '<input type="button" value="'.$Key.'" onclick="bbcode (\'commentcontent\', \''.$Key.'\')" id="BBC_'.$Key.'" title="'.$Value.'" class="button" />
';
             foreach ($Emoticons as $Key => $Value) $EmoticonsList.= '<img src="'.EBROWSER_PATH.'share/icons/'.$GLOBALS['ThemeConfiguration']['Icons'].'/emoticons/'.$Value.'.png" alt="'.$Key.'" title="'.$Key.'" onclick="emoticon (\'commentcontent\', \'['.$Key.']\')" />
';
             if (isset ($_GET['commentedit']) && defined ('EBROWSER_ADMIN')) $Array = $DB->comments_array ($Path, $_GET['commentedit']);
             else $Array = 0;
             $Chars = array_merge (range ('A', 'Z'), range (1, 9));
             $_SESSION['eBrowser']['confirm'] = '';
             for ($i = 0; $i < 5; $i++) $_SESSION['eBrowser']['confirm'].= $Chars[mt_rand (0, count ($Chars) - 1)];
             $Page.= e_theme_parse ($Theme['comment-form'], array (
	'title' => ($Array?e_i18n ('Edit comment'):e_i18n ('Add comment')),
	'content' => ($Array?htmlspecialchars ($Array['content']):''),
	'active' => (($Array && $Array['active'])?' checked="checked"':''),
	'author' => (e_cookie_get ('author')?e_cookie_get ('author'):($Array?htmlspecialchars ($Array['author']):'')),
	'url' => (e_cookie_get ('url')?e_cookie_get ('url'):($Array?htmlspecialchars ($Array['url']):'')),
	'commentid' => ($Array?'<input type="hidden" name="commentid" value="'.(int) $Array['time'].'" />
':''),
	'format' => $BBCodeList,
	'emoticons' => $EmoticonsList
	));
             }
          $PathElements = array ();
          $LocalPath = $Path;
          $MainDirectory = (($FileSystem->type () == 'archive')?'/':$FileSystem->prefix ().'/');
          if ($FileSystem->type () == 'archive') $MainFileSystem = e_file_system_model ('/');
          else $MainFileSystem = &$FileSystem;
          $MainInformation = $MainFileSystem->information ($MainDirectory);
          $End = 0;
          while (!$End) {
                if ($LocalPath == $MainDirectory) {
                   $Name = &$MainInformation['name'];
                   $End = 1;
                   }
                else {
                     $Name = basename ($LocalPath);
                     if (strstr ($Name, '@')) $Name = substr ($Name, (strpos ($Name, '@') + 1));
                     }
                if (!$ThemeConfiguration['SimpleMenu']) $List = implode ('', e_entries_list ($LocalPath, 0, 1));
                $PathElements[] = ($End?'':'<strong class="separator">›</strong>
').'<div>
<a href="{path}'.$LocalPath.'">'.(($LocalPath == $Path)?'<strong>'.$Name.'</strong></a>
':$Name.'</a>
').((!$ThemeConfiguration['SimpleMenu'] && $List)?'<ul class="menulist">
'.$List.'</ul>
':'').'</div>
';
                if ($ThemeConfiguration['ShowLocation']) $LocationArray = e_entries_list ($LocalPath, $LocationArray);
                $LocalPath = e_path_parent ($LocalPath);
                }
          $Theme['locationbar'] = (($_COOKIE['eBrowserView'] == 'tree' && $FileSystemInformation['browseable'])?'':'<form action="{self}" method="post">
<div id="locationbar">
'.($ThemeConfiguration['SimpleMenu']?'':'<img src="'.e_icon_path ('rotate-left', 'miscellaneous').'" alt="" id="switchlocation" title="'.e_i18n ('Switch style of navigation bar').'" onclick="navigationBar ()" />
').'<div id="locationnavigate" style="display:'.((!isset ($_COOKIE['eBrowserNavigationBarEdit']) || $_COOKIE['eBrowserNavigationBarEdit'] == 'false' || $ThemeConfiguration['SimpleMenu'])?'block':'none').'">
<img src="'.(($FileSystem->type () == 'archive')?e_icon_path ('archive'):$MainInformation['icon']).'" alt="'.$FileSystem->type ().'" id="filesystemicon" />
'.implode ('', array_reverse ($PathElements)).'</div>
'.($ThemeConfiguration['SimpleMenu']?'':'<div id="locationedit" style="display:'.(((!isset ($_COOKIE['eBrowserNavigationBarEdit']) || $_COOKIE['eBrowserNavigationBarEdit'] == 'false'))?'none':'block').'">
<input name="address" value="{address}" id="address" accesskey="G" />
<input type="submit" value="'.e_i18n ('Go').'" class="button" />
</div>
').'</div>
</form>
');
          }
     }
if (defined ('EBROWSER_ADMIN')) $Theme['announcements'] = e_announce (e_i18n ('You are in admin mode!'), 'warning').$Theme['announcements'];
$Theme['db'] = (int) ($DB !== 0);
$Theme['address'] = (($_COOKIE['eBrowserView'] == 'tree')?'/':($Path?htmlspecialchars ($Path):'/'));
$Theme['theme'] = $_SESSION['eBrowser']['theme'];
$Theme['form'] = ((count ($Locales) > 1 || count ($Themes) > 1)?((count ($Locales) > 1)?'<select name="language" title="'.e_i18n ('Choose language').'" tabindex="'.(++$TabIndex).'">
'.$SelectLocale.'</select>
':'').((count ($Themes) > 1)?'<select name="theme" title="'.e_i18n ('Choose theme').'" tabindex="'.(++$TabIndex).'">
'.$SelectTheme.'</select>
':'').'<input type="submit" value="'.e_i18n ('Change').'" class="button" tabindex="'.(++$TabIndex).'" />
':'');
$Theme['logoutarea'] = ((!defined ('EBROWSER_ADMIN') && defined ('EBROWSER_AREA'))?'='.$FileSystemInformation['area']:'');
$Theme['language'] = $_SESSION['eBrowser']['language'];
$Theme['browser'] = $Page;
$Theme['viewmode'] = (isset ($_COOKIE['eBrowserView'])?$_COOKIE['eBrowserView']:'icons');
$Theme['activelocationid'] = 'location_'.md5 ('location.'.(is_dir ('.'.$Path)?substr ($Path, 0, -1):$Path));
$Theme['viewpreview'] = ($_COOKIE['eBrowserPreview']?' class="active"':'');
for ($i = 0, $c = count ($Views); $i < $c; ++$i) $Theme['view'.$Views[$i]] = (($_COOKIE['eBrowserView'] == $Views[$i])?' class="active"':'');
$Thumbnail = '';
$Emblems = e_entry_emblems ($MainInformation, $MainFileSystem);
$Summary = e_entry_summary ($MainInformation, $MainFileSystem, $Thumbnail, $Emblems);
$Theme['location'] = ($ThemeConfiguration['ShowLocation']?'<ul>
<li>
<img src="'.$MainInformation['icon'].'" alt="'.$MainFileSystem->type ().'" title="'.e_i18n ('Show / hide').'" id="location_34403cd13ba8314730006f8645a178e6_icon" onclick="directoryShowHide (\''.$MainInformation['path'].'\', \'location_34403cd13ba8314730006f8645a178e6\');" />
<a href="{path}'.$MainInformation['path'].'">
'.$MainInformation['name'].'
</a>
<div id="summary_entries_location_34403cd13ba8314730006f8645a178e6" style="display:none;">
'.$Summary.'</div>
<script type="text/javascript">
Locations[\'location_34403cd13ba8314730006f8645a178e6\'] = \''.$MainInformation['path'].'\';
</script>
<ul id="location_34403cd13ba8314730006f8645a178e6">
'.implode ('', $LocationArray).'</ul>
</li>
</ul>
':'');
$Theme['view'] = $_COOKIE['eBrowserView'];
$Theme['activelocation'] = 'location_'.md5 ($FileSystemInformation['path']);
if (is_file (EBROWSER_PATH.'share/themes/'.$_SESSION['eBrowser']['theme'].'/theme.php')) include (EBROWSER_PATH.'share/themes/'.$_SESSION['eBrowser']['theme'].'/theme.php');
if (isset ($FileSystemInformation['description']) && $FileSystemInformation['description']) $Information[] = array ($FileSystemInformation['description'], 'information');
if ($c = count ($Information)) {
   for ($i = 0; $i < $c; ++$i) $Theme['announcements'].= e_announce ($Information[$i][0], $Information[$i][1]);
   }
$Page = e_theme_parse (e_theme_parse ($Theme['page'], $Theme), $Theme);
$ThemeSwitch = array (
	'admin' => defined ('EBROWSER_ADMIN'),
	'login' => (defined ('EBROWSER_ADMIN') || defined ('EBROWSER_AREA')),
	'ftp' => function_exists ('ftp_connect'),
	'directory' => (isset ($FileSystemInformation) && $FileSystemInformation['browseable'] && $FileSystemInformation['size'] && $FileSystem->type () != 'trash'),
	'db' => $DB,
	'tree' => ($_COOKIE['eBrowserView'] == 'tree')
	);
$Page = e_theme_switches ($Page, $ThemeSwitch);
if (isset ($FileSystemInformation['time']) && $FileSystemInformation['time']) header ('Last-Modified: '.gmdate ('r', $FileSystemInformation['time']));
header ($ThemeConfiguration['Header']);
if ($ERRORS && defined ('EBROWSER_ADMIN')) $Debug = e_announce ('<strong>'.e_i18n ('Debug').' ('.$ECounter.'):</strong><br />
<div id="debug">
'.rtrim ($ERRORS, "\r\n").'
</div>', 'information');
else $Debug = '';
$Page = e_theme_parse ($Page, array (
	'pagegeneration' => e_i18n ('Page generation time').': '.round (array_sum (explode (' ', microtime ())) - $Start, 5),
	'debug' => $Debug
	));
if ($ThemeConfiguration['Type'] != 'xhtml') $Page = str_replace (' />', '>', $Page);
die (preg_replace ('#(\{tabindex\})#e', '++$TabIndex', $Page));
?>