<?php
class ebrowser_vfs_bookmarks {
private $Bookmarks;
private function path ($Path) {
	if (substr ($Path, 0, 11) == 'bookmarks:/') $Path = substr ($Path, 11);
	return ($Path);
	}
public function __construct ($Path) {
	if (e_cookie_get ('bookmarks')) $this->Bookmarks = e_cookie_get ('bookmarks');
	}
public function refresh () {
	$this->Information = $this->Entries = array ();
	}
public function type () {
	return ('bookmarks');
	}
public function prefix () {
	return ('bookmarks:');
	}
public function exists ($Path) {
	$Path = $this->path ($Path);
	return (!$Path || isset ($this->Bookmarks[$Path]));
	}
public function delete ($Path) {
	$Path = $this->path ($Path);
	if (isset ($this->Bookmarks[$Path])) unset ($this->Bookmarks[$Path]);
	setcookie (md5 ($GLOBALS['UniqueID'].'bookmarks'), serialize ($this->Bookmarks), ($_SERVER['REQUEST_TIME'] + 31536000), $GLOBALS['DirName']);
	return (1);
	}
public function entries ($Path = '', $Exclude = '') {
	if (!$this->Bookmarks) return (array ());
	$Path = $this->path ($Path);
	$Array = array ();
	$Length = strlen ($Path);
	foreach ($this->Bookmarks as $Key => $Value) {
		if ($Path) {
			$Sub = substr ($Key, 0, $Length);
			if ($Sub != $Path || $Path == $Key) continue;
			$Sub = substr ($Key, $Length);
			}
		else $Sub = &$Key;
		$Tmp = substr_count ($Sub, '/');
		if ($Tmp > 1 || ($Tmp == 1 && substr ($Sub, -1) != '/')) continue;
		$Array[] = $Key;
		}
	return ($Array);
	}
public function information ($Path) {
	$Path = $this->path ($Path);
	if (!$Path) return (e_file_information (array (
	'icon' => e_icon_path ('folder-bookmarks'),
	'name' => e_i18n ('Bookmarks'),
	'path' => 'bookmarks:/',
	'readable' => 1,
	'size' => count ($this->entries ()),
	'time' => 0,
	'writeable' => 1
	)));
	$IsDirectory = (substr ($Path, '-1') == '/' && !$this->Bookmarks[$Path]);
	if (!$IsDirectory) {
		$FileSystem = e_file_system_model ($this->Bookmarks[$Path]);
		if ($FileSystem->information ($this->Bookmarks[$Path])) return ($FileSystem->information ($this->Bookmarks[$Path]));
		}
	return (e_file_information (array (
	'address' => ($IsDirectory?0:$this->Bookmarks[$Path]),
	'bookmarks' => $IsDirectory,
	'directory' => $IsDirectory,
	'extension' => 'URL',
	'icon' => e_icon_path ($IsDirectory?'folder-bookmarks':'url'),
	'name' => basename ($Path, '/'),
	'path' => ($IsDirectory?'bookmarks:/':'').$Path,
	'readable' => 1,
	'size' => ($IsDirectory?count ($this->entries ($Path)):0),
	'time' => 0,
	'writeable' => 1
	)));
	}
}
?>