<?php
class ebrowser_vfs_tags {
private function path ($Path) {
	if (substr ($Path, 0, 6) == 'tags:/') {
		$Path = substr ($Path, 6);
		if (substr ($Path, -1) == '/') $Path = basename ($Path, '/');
		}
	return ($Path);
	}
public function __construct ($Path) {}
public function refresh () {
	$this->Information = $this->Entries = array ();
	}
public function type () {
	return ('tags');
	}
public function prefix () {
	return ('tags:');
	}
public function exists ($Path) {
	$Path = $this->path ($Path);
	if (!$Path) return (1);
	return ($GLOBALS['DB']->tags_amount ($Path));
	}
public function delete ($Path) {
	$Path = $this->path ($Path);
	$GLOBALS['DB']->tags_delete ($Path);
	return (1);
	}
public function entries ($Path = '', $Exclude = '') {
	$Path = $this->path ($Path);
	if (!$Path) return ($GLOBALS['DB']->tags_list ());
	$Tags = $GLOBALS['DB']->tags_array ($Path);
	$Array = array ();
	for ($i = 0, $c = count ($Tags); $i < $c; ++$i) {
		$FileSystem = e_file_system_model ($Tags[$i]['path']);
		if (!$FileSystem->exists ($Tags[$i]['path'])) {
			$GLOBALS['DB']->location_update ($Tags[$i]['path']);
			continue;
			}
		$Array[] = &$Tags[$i]['path'];
		}
	return ($Array);
	}
public function information ($Path) {
	$Path = $this->path ($Path);
	if (!$Path) return (e_file_information (array (
	'icon' => e_icon_path ('folder-tags'),
	'name' => e_i18n ('Tags'),
	'path' => 'tags:/',
	'readable' => 1,
	'size' => count ($this->entries ()),
	'time' => 0,
	'writeable' => 1
	)));
	if ($GLOBALS['DB']->tags_amount ($Path)) return (e_file_information (array (
	'directory' => 1,
	'icon' => e_icon_path ('folder-tags'),
	'name' => &$Path,
	'path' => 'tags:/'.$Path.'/',
	'readable' => 1,
	'size' => $GLOBALS['DB']->tags_amount ($Path),
	'time' => 0,
	'writeable' => 0
	)));
	$FileSystem = e_file_system_model ($Path);
	return ($FileSystem->information ($Path));
	}
}
?>