<?php
class ebrowser_vfs_trash {
private function path ($Path) {
	if (substr ($Path, 0, 7) == 'trash:/') $Path = substr ($Path, 8);
	return ($Path);
	}
public function __construct ($Path) {
	if (!defined ('EBROWSER_ADMIN')) throw new Exception ();
	}
public function refresh () {
	$this->Information = $this->Entries = array ();
	}
public function type () {
	return ('trash');
	}
public function prefix () {
	return ('trash:');
	}
public function exists ($Path) {
	$Path = $this->path ($Path);
	if (!$Path) return (1);
	$FileSystem = e_file_system_model ($Path);
	return ($FileSystem->exists ($Path));
	}
public function delete ($Path) {
	$Path = $this->path ($Path);
	$FileSystem = e_file_system_model ($Path);
	return ($FileSystem->delete ($Path));
	}
public function entries ($Path = '', $Exclude = '') {
	$Trash = $GLOBALS['DB']->trash_array ();
	$Array = array ();
	for ($i = 0, $c = count ($Trash); $i < $c; ++$i) {
		if (!$this->exists ($Trash[$i]['path'])) {
			$GLOBALS['DB']->location_update ($Trash[$i]['path']);
			continue;
			}
		$Array[] = &$Trash[$i]['path'];
		}
	return ($Array);
	}
public function information ($Path) {
	$Path = $this->path ($Path);
	if (!$Path) return (e_file_information (array (
	'icon' => e_icon_path ('trash'),
	'path' => 'trash:/',
	'name' => e_i18n ('Trash'),
	'size' => count ($this->entries ()),
	'time' => 0,
	'trash' => 1
	)));
	$FileSystem = e_file_system_model ($Path);
	return ($FileSystem->information ($Path));
	}
}
?>