[start:page]<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{language}" dir="{dir}" id="html">
<head>
<title>eBrowser :: {address}</title>
<link href="{datapath}share/icons/Oxygen/miscellaneous/ebrowser.png" rel="shortcut icon" type="image/png" />
<link href="{datapath}share/themes/{theme}/theme.css" rel="stylesheet" type="text/css" title="{theme}" />
<script type="text/javascript">
/* <![CDATA[ */
DB = {db};
UpdateSidebar = {updatesidebar};
View = '{view}';
Path = '{path}';
DataPath = '{datapath}';
Address = '{address}';
Icons = '{icontheme}';
StringClose = '{lang_close}';
BlockInformation = '<' + 'div><' + 'h3>{lang_information}</h3><' + 'div id="entry_information"></div></div>';
function showLoading (Mode) {
	document.getElementById ('loadingindicatoricon').src = '{datapath}share/icons/Oxygen/miscellaneous/' + (Mode?'loading.gif':'ebrowser.png');
	document.getElementById ('loadingindicator').title = (Mode?'{lang_loading}':'{lang_about}');
	}
/* ]]> */
</script>
<script type="text/javascript" src="{datapath}lib/functions.js"></script>
</head>
<body onload="showLoading (0); init ('{activelocation}');">
<div id="body">
<div id="header">
<form action="{self}" method="post" id="form">
<div>
<a href="{path}{address}{separator}request&amp;show&amp;window=about" tabindex="1" accesskey="A" title="{lang_about}" id="loadingindicator">
<img src="{datapath}share/icons/Oxygen/miscellaneous/ebrowser.png" alt="" id="loadingindicatoricon" />
</a>
<!--start:login--><a href="{path}{separator}logout{logoutarea}" tabindex="2" accesskey="L" title="{lang_logout}">
<img src="{datapath}share/icons/Oxygen/miscellaneous/logout.png" alt="logout" />
</a>
<a href="{path}{address}{separator}request&amp;show&amp;window=configuration" tabindex="3" accesskey="C" title="{lang_configuration}">
<img src="{datapath}share/icons/Oxygen/miscellaneous/configure.png" alt="configure" />
</a><!--end:login--><!--start:!admin--><a href="{path}{address}{separator}request&amp;show&amp;window=login" tabindex="2" accesskey="L" title="{lang_login}">
<img src="{datapath}share/icons/Oxygen/miscellaneous/password.png" alt="login" />
</a>
<!--end:!admin--><script type="text/javascript">
showLoading (1);
</script>
{form}</div>
</form>
<h1>
{lang_ebrowser}
</h1>
</div>
<div id="windowscontainer">
{windows}</div>
<div id="announcements">
<!--[if IE]>
<div class="warning">
{lang_iewarning}
</div>
<![endif]-->
{announcements}{debug}</div>
{locationbar}<div id="sidebar">
<div id="information">
{information}</div>
</div>
<div id="browser" class="{viewmode}">
{browser}<div class="clear"></div>
</div>
{statusbar}<div id="footer">
<span class="copy">
<em>eBrowser</em>
&copy; 2005 - 2008
<a href="http://emdek.cba.pl/" tabindex="{tabindex}">
<strong>Emdek</strong>
</a>
</span>
<small>
{pagegeneration}
<a href="#html" tabindex="{tabindex}" title="{lang_gototop}"><strong>^</strong></a>
</small>
</div>
</div>
</body>
</html>[/end]

[start:slideshow]<div id="slideshowcontainer">
<div class="toolbar" id="controls">
<div id="slideinformation">
<strong id="slide_number"></strong>
<div id="slide_progress"><div></div></div>
</div>
<img src="{datapath}share/icons/Oxygen/toolbar/fileview-preview.png" alt="thumbnails" id="slideshow_thumbnails" class="active" onclick="slideShowThumbnailsShowHide ()" title="{lang_thumbnails}" />
<img src="{datapath}share/icons/Oxygen/toolbar/media-skip-backward.png" alt="first" onclick="slideShowDisplay (0, 1)" title="{lang_first}" />
<img src="{datapath}share/icons/Oxygen/toolbar/media-seek-backward.png" alt="previous" onclick="slideShowDisplay ((CurrentSlide - 1), 1)" title="{lang_previous}" />
<img src="{datapath}share/icons/Oxygen/toolbar/media-pause.png" alt="play / pause" id="slideshow_startpause" onclick="slideShowStartPause ()" title="{lang_startpause}" />
<img src="{datapath}share/icons/Oxygen/toolbar/media-stop.png" alt="stop" onclick="location.reload (true)" title="{lang_stop}" />
<img src="{datapath}share/icons/Oxygen/toolbar/media-seek-forward.png" alt="next" onclick="slideShowDisplay ((CurrentSlide + 1), 1)" title="{lang_next}" />
<img src="{datapath}share/icons/Oxygen/toolbar/media-skip-forward.png" alt="last" onclick="slideShowDisplay (-1, 1)" title="{lang_last}" />
</div>
<div id="slideshow_loading">
<img src="{datapath}share/icons/Oxygen/miscellaneous/loading-big.gif" alt="loading" /><br />
<strong>{lang_loading}</strong>
</div>
<div id="slideshow">
<img src="" alt="" id="slideshow_image" onclick="imageResize ('slideshow')" />
</div>
<div id="slideshow_information">
<span id="slideshow_path"></span>
(<span id="slideshow_size"></span>)
</div>
<div id="slideshow_description"></div>
<div id="thumbnailsbar">
{thumbnails}</div>
</div>
[/end]

[start:announcement]<div class="{class}" title="{type}">
{content}
</div>
[/end]

[start:window]<div class="window" id="window_{id}">
<h4>
{title}
</h4>
{content}
</div>
[/end]

[start:information]<h3>
{lang_information}
</h3>
{information}[/end]

[start:information-actions][/end]

[start:comment]<div class="comment">
<h4>
<em><a href="{self}#comment_{id}" tabindex="{tabindex}" id="comment_{id}">{date}</a></em>{author}
</h4>
{content}
{information}</div>
[/end]

[start:comment-form]<div class="comment" id="commentform">
<h3>
{title}
</h3>
<div class="format">
{format}</div>
<div class="emoticons">
{emoticons}</div>
<form action="{self}" method="post">
<p>
<span>
<input name="commentauthor" value="{author}" id="commentauthor" tabindex="{tabindex}" />
</span>
<label for="commentauthor">{lang_signature}</label>:
</p>
<p>
<span>
<input name="commenturl" value="{url}" id="commenturl" tabindex="{tabindex}" />
</span>
<label for="commenturl">{lang_address}</label>:
</p>
<!--start:admin--><p>
<span>
<input type="checkbox" name="commentactive" value="1" id="commentactive"{active} tabindex="{tabindex}" />
</span>
<label for="commentactive">{lang_active}</label>:
</p>
<!--end:admin--><!--start:!admin--><p>
<span>
<input name="commentconfirm" id="commentconfirm" tabindex="{tabindex}" />
</span>
<label for="commentconfirm">{lang_confirmimage}</label>:<br />
<img src="{path}{separator}request&amp;confirm" alt="" />
</p>
<!--end:!admin--><h3>
<input type="button" value="&#9660;" title="{lang_increasefield}" onclick="document.getElementById('commentcontent').rows += 5" class="button" style="float:left;" tabindex="{tabindex}" />
<label for="commentcontent">{lang_content}</label>
<input type="button" value="&#9650;" title="{lang_decreasefield}" onclick="document.getElementById('commentcontent').rows -= 5" class="button" style="float:right;" tabindex="{tabindex}" />
</h3>
<p>
<textarea name="commentcontent" rows="5" cols="50" id="commentcontent" tabindex="{tabindex}">
{content}</textarea>
</p>
<div class="buttons">
<input type="submit" value="{lang_save}" tabindex="{tabindex}" class="button" />
{commentid}</div>
</form>
</div>
[/end]