CursorX = 0;
CursorY = 0;
SlideShow = 0;
Shortcuts = 1;
EntryNumber = 0;
EntriesAmount = 0;
ActiveLocation = '';
ActiveEntry = '';
Entries = new Object;
Locations = new Object;
CurrentTab = new Array;
Windows = new Array;
if (!Array.prototype.indexOf) {
	Array.prototype.indexOf = function (element) {
		for (i = 0; i < this.length; i++) {
			if (i in this && this[i] === element) return (i);
			}
		return (-1);
		};
	}
function elementWidth (ID) {
	return (document.getElementById (ID).clientWidth?document.getElementById (ID).clientWidth + 'px':window.getComputedStyle (document.getElementById (ID), '').getPropertyValue ('width'));
	}
function elementHeight (ID) {
	return (document.getElementById (ID).clientHeight?document.getElementById (ID).clientHeight + 'px':window.getComputedStyle (document.getElementById (ID), '').getPropertyValue ('height'));
	}
function init (ID) {
	document.onmousemove = mouseEvent;
	document.onkeypress = keyboardEvent;
	if (document.getElementById ('search')) document.getElementById ('search').onkeypress = pageSearch;
	if (document.getElementById ('sidebar')) document.getElementById ('sidebar').style.minHeight = elementHeight ('browser');
	for (ID in Entries) document.getElementById ('tooltip_' + ID).className = '';
	ActiveLocation = ID;
	if (document.getElementById (ID + '_icon')) document.getElementById (ID + '_icon').style.opacity = 0.7;
	}
function keyboardEvent (Event) {
	if (!Entries || !Shortcuts) return (0);
	Event = (Event?Event:(window.Event?window.Event:null));
	if (Event) {
		Key = (Event.charCode?Event.charCode:(Event.keyCode?Event.keyCode:(Event.which?Event.which:0)));
		if (SlideShow && (Key == 27 || Key == 32 || Key == 37 || Key == 38 || Key == 39 || Key == 40 || Key == 102 || Key == 108 || Key == 110 || Key == 112 || Key == 115 || Key == 116)) {
			if (Key == 38 || Key == 39 || Key == 110) slideShowDisplay ((CurrentSlide + 1), 1);
			else if (Key == 37 || Key == 40 || Key == 112) slideShowDisplay ((CurrentSlide - 1), 1);
			else if (Key == 102) slideShowDisplay (0, 1);
			else if (Key == 108) slideShowDisplay (-1, 1);
			else if (Key == 116) slideShowThumbnailsShowHide ();
			else if (Key == 32) slideShowStartPause ();
			else {
				showHide ('body', 1);
				showHide ('slideshowcontainer', 0);
				document.getElementById ('slideshow').id = '';
				SlideShow = null;
				}
			}
		else if (Key == 13 || Key == 37 || Key == 38 || Key == 39 || Key == 40 || Key == 110 || Key == 112) {
			if (Key == 13) {
				if (!Entries[ActiveEntry]) return;
				if (View == 'tree' && Entries[ActiveEntry]['type'] == 'directory') {
					if (document.getElementById('tree_' + ActiveEntry).className) scriptLoad (Path + '&request&list=' + escape (Entries[ActiveEntry]['path']) + '&id=tree_' + ActiveEntry, 0)
					directoryShowHide (Entries[ActiveEntry]['path'], 'tree_' + ActiveEntry);
					return;
					}
				else document.location = Path + Entries[ActiveEntry]['path'];
				}
			if (ActiveEntry) ActiveEntryNumber = Entries[ActiveEntry]['number'];
			else ActiveEntryNumber = -1;
			if (Key == 37 || Key == 38 || Key == 112) ActiveEntryNumber--;
			else ActiveEntryNumber++;
			if (ActiveEntryNumber < 0) ActiveEntryNumber = (EntriesAmount - 1);
			if (ActiveEntryNumber == EntriesAmount) ActiveEntryNumber = 0;
			for (id in Entries) {
				if (Entries[id]['number'] == ActiveEntryNumber) entrySelect (id);
				}
			}
		}
	}
function mouseEvent (Event) {
	if (document.all) {
		CursorX = Event.clientX + document.body.scrollLeft;
		CursorY = Event.clientY + document.body.scrollTop;
		}
	else {
		CursorX = Event.pageX;
		CursorY = Event.pageY;
		}
	}
function cookieSet (Name, Value) {
	Time = new Date ();
	Time.setTime (Time.getTime () + 31536000);
	document.cookie = Name + '=' + escape (Value) + '; expires=' + (Value?Time.toGMTString ():-1) + '; path=' + escape ('/');
	}
function cookieGet (Name) {
	Name = Name + '=';
	Cookies = document.cookie.split (';');
	for (i = 0; i < Cookies.length; i++) {
		while (Cookies[i].charAt (0) == ' ') Cookies[i] = Cookies[i].substr (1, Cookies[i].length);
		if (Cookies[i].indexOf (Name) == 0) return (unescape (Cookies[i].substr (Name.length, Cookies[i].length)));
		}
	return ('');
	}
function entrySelect (ID) {
	if (!UpdateSidebar) return;
	if (document.getElementById ('entry_' + ID).className == 'entry active') document.getElementById ('entry_' + ID).className = 'entry';
	else document.getElementById ('entry_' + ID).className = 'entry active';
	document.getElementById ('information').innerHTML = BlockInformation;
	document.getElementById ('entry_information').innerHTML = '';
	document.getElementById ('entry_information').innerHTML = document.getElementById ('tooltip_' + ID).innerHTML;
	scriptLoad (Path + Address + '&request&actions=' + Entries[ID]['path'], 0);
	if (ActiveEntry) document.getElementById ('entry_' + ActiveEntry).className = 'entry';
	ActiveEntry = ID;
	}
function showHide (ID, Mode) {
	if (document.getElementById (ID).tagName.toLowerCase () == 'tr') {
		TDs = document.getElementById (ID).getElementsByTagName ('td');
		for (j = 0; j < TDs.length; j++) TDs[j].style.display = (Mode?'table-cell':'none');
		}
	else document.getElementById (ID).style.display = (Mode?'block':'none');
	}
function directoryShowHide (Location, ID) {
	if (Location != 'trash:/') showHide (ID, (document.getElementById (ID).style.display == 'none'));
	if (document.getElementById (ActiveLocation + '_icon')) document.getElementById (ActiveLocation + '_icon').style.opacity = 1;
	if (ID) {
		ActiveLocation = ID;
		if (document.getElementById (ID + '_icon')) document.getElementById (ID + '_icon').style.opacity = 0.7;
		}
	if (ID.substr (0, 4) != 'tree' && ID.substr (0, 9) != 'bookmarks') {
		document.getElementById ('information').innerHTML = BlockInformation;
		document.getElementById ('entry_information').innerHTML = '';
		document.getElementById ('entry_information').innerHTML = document.getElementById ('summary_entries_' + ID).innerHTML;
		}
	scriptLoad (Path + Address + '&request&actions=' + Locations[ID], 0);
	}
function scriptLoad (Path, Information) {
	AutoCloseID = 'actions_' + Math.random ();
	if (Information) announce (Information, 'loading', 0, AutoCloseID);
	Time = new Date ();
	script = document.createElement ('script');
	script.type = 'text/javascript';
	script.src = Path + '&amp;' + Time.getTime ();
	showLoading (1);
	document.getElementsByTagName ('head')[0].appendChild (script);
	}
function tabSwitch (ID, Tab, Init) {
	if (Init) {
		Tabs = document.getElementById (ID).getElementsByTagName ('div');
		for (i = 0; i < Tabs.length; i++) {
			if (Tabs[i].id.substr (0, (ID.length + 4)) == ID + '_tab') Tabs[i].style.display = 'none';
			}
		}
	else {
		document.getElementById (ID + '_tab_' + CurrentTab[ID]).className = '';
		document.getElementById (ID + '_tabcontent_' + CurrentTab[ID]).style.display = 'none';
		}
	CurrentTab[ID] = Tab;
	document.getElementById (ID + '_tab_' + Tab).className = 'active';
	document.getElementById (ID + '_tabcontent_' + Tab).style.display = 'block';
	}
function windowShowHide (ID) {
	if (Windows.indexOf (ID) < 0) {
		scriptLoad (Path + Address + '&request&window=' + ID, 0);
		display = 0;
		}
	else {
		display = (document.getElementById ('window_' + ID).style.display != 'none');
		document.getElementById ('window_' + ID).style.display = (display?'none':'block');
		}
	document.getElementById ('button_' + ID).className = (display?'':'active');
	Shortcuts = display;
	}
function announce (Text, Type, Close, ID) {
	if (!ID) ID = 'actions_' + Math.random ();
	document.getElementById ('announcements').innerHTML += '<div id="' + ID + '" class="' + Type + '">\n' + (Close?'<span class="button" onclick="document.getElementById (\'' + ID + '\').style.display = \'none\'">' + StringClose + '</span>\n':'') + Text + '\n</div>\n';
	}
function announceReplace (Text, Type, Close, ID) {
	announce (Text, Type, Close, 0);
	showHide (ID, 0);
	showLoading (0);
	}
function imageResize (ID) {
	document.getElementById (ID + '_image').style.maxHeight = (ResizeMode?document.getElementById (ID).clientHeight + 'px':'10000px');
	document.getElementById (ID + '_image').style.maxWidth = (ResizeMode?document.getElementById (ID).clientWidth + 'px':'10000px');
	ResizeMode = !ResizeMode;
	ImageInformation = new Image ();
	ImageInformation.src = document.getElementById (ID + '_image').src;
	Width = elementWidth (ID + '_image');
	Width = Math.round ((Width.substr (0, (Width.length - 2)) / ImageInformation.width) * 100);
	if (Width < 100) document.getElementById (ID + '_image').style.cursor = 'pointer';
	Information = ImageInformation.width + ' x ' + ImageInformation.height + ', ' + ((Width > 100)?100:Width) + '%';
	if (document.getElementById (ID + '_size')) document.getElementById (ID + '_size').innerHTML = Information;
	else document.getElementById ('statusbar').innerHTML += ' (<span id="filepreview_size">' + Information + '</span>)';
	if (document.getElementById ('sidebar')) document.getElementById ('sidebar').style.minHeight = elementHeight ('browser');
	}
function slideShowThumbnailsShowHide () {
	document.getElementById ('slideshow').style.height = ((window.innerHeight?window.innerHeight:(document.body.clientHeight?document.body.clientHeight:document.documentElement.clientHeight)) - ((SlideShowThumbnails?125:290) + document.getElementById ('slideshow_description').clientHeight)) + 'px';
	ResizeMode = 1;
	imageResize ('slideshow');
	document.getElementById ('slideshow_thumbnails').className = (SlideShowThumbnails?'':'active');
	document.getElementById ('thumbnailsbar').style.display = (SlideShowThumbnails?'none':'block');
	SlideShowThumbnails = !SlideShowThumbnails;
	}
function slideShowStartPause () {
	document.getElementById ('slideshow_startpause').src = DataPath + 'share/icons/' + Icons + '/toolbar/media-' + (SlideShowActive?'start':'pause') + '.png';
	document.getElementById ('slide_progress').style.display = 'none';
	SlideShowActive = !SlideShowActive;
	clearInterval (SlideShowAuto);
	if (SlideShowActive) slideShow (CurrentSlide);
	}
function slideShowDisplay (Slide, Pause) {
	if (Pause && SlideShowActive) slideShowStartPause ();
	if (Slide == -1) Slide = (SlideShow.length - 1);
	else if (Slide >= SlideShow.length) Slide = 0;
	document.getElementById ('slide_progress').style.display = ((!Pause && Slide < (SlideShow.length - 1))?'block':'none');
	document.getElementById ('slide_thumbnail_' + CurrentSlide).style.opacity = '0.5';
	CurrentSlide = Slide;
	clearInterval (SlideProgress);
	SlideProgressAmount = 0;
	SlideLoading = window.setInterval (function () {
		if (SlideShow[CurrentSlide][3].complete) {
			clearInterval (SlideLoading);
			showHide ('slideshow_loading', 0);
			showHide ('slideshow_information', 1);
			showHide ('slideshow_description', 1);
			document.getElementById ('slide_progress').getElementsByTagName ('div')[0].style.width = 0;
			document.getElementById ('slideshow_path').innerHTML = '<a href="' + Path + SlideShow[CurrentSlide][0] + '">' + SlideShow[CurrentSlide][0] + '</a>';
			document.getElementById ('slideshow_description').innerHTML = SlideShow[CurrentSlide][1];
			document.getElementById ('slideshow_image').src = SlideShow[CurrentSlide][3].src;
			document.getElementById ('slideshow_image').style.display = 'inline';
			document.getElementById ('slide_number').innerHTML = (CurrentSlide + 1) + ' / ' + SlideShow.length;
			document.getElementById ('slide_thumbnail_' + CurrentSlide).style.opacity = '1';
			document.getElementById ('slideshow').style.height = ((window.innerHeight?window.innerHeight:(document.body.clientHeight?document.body.clientHeight:document.documentElement.clientHeight)) - ((SlideShowThumbnails?290:125) + document.getElementById ('slideshow_description').clientHeight)) + 'px';
			ResizeMode = 1;
			imageResize ('slideshow');
			if (Slide < (SlideShow.length - 1)) SlideProgress = window.setInterval (function () {
				if (SlideProgressAmount == 50) clearInterval (SlideProgress);
				document.getElementById ('slide_progress').getElementsByTagName ('div')[0].style.width = (++SlideProgressAmount) + 'px';
				}, 100);
			}
		else showHide ('slideshow_loading', 1);
		}, 100);
	}
function slideShow (CurrentSlide) {
	slideShowDisplay ((CurrentSlide++), 0);
	SlideShowAuto = window.setInterval (function () {
		if (!SlideShowActive || CurrentSlide == SlideShow.length) {
			clearInterval (SlideShowAuto);
			return;
			}
		slideShowDisplay (CurrentSlide, 0);
		CurrentSlide++;
		}, 5000);
	}
function iconSelect (Icon) {
	document.getElementById ('iconselector_input').value = Icon;
	document.getElementById ('iconselector_preview').src = Icon;
	}
function tooltipDelay (ID, Mode) {
	if (!Mode) clearTimeout (Interval);
	Interval = window.setTimeout (function (ID) {
		document.getElementById (ID).style.left = (CursorX + 20) + 'px';
		document.getElementById (ID).style.top = (CursorY + 20) + 'px';
		document.getElementById (ID).className = (Mode?'delaytooltip':'');
		}, 1000, ID);
	}
function pageSearch () {
	Interval = window.setTimeout (function () {
		Query = document.getElementById ('search').value.toLowerCase ();
		for (ID in Entries) {
			Found = 0;
			Elements = document.getElementById ('entry_' + ID).getElementsByTagName ('em');
			for (j = 0; j < Elements.length; j++) {
				String = Elements[j].innerHTML;
				String = ' ' + String.replace (/<\/?[^>]+>/gi, '') + ' ';
				if (String.toLowerCase ().split (Query).length > 1) Found = 1;
				}
			showHide ('entry_' + ID, Found);
			}
		}, 100);
	}
function pageFilterGroup (ID, Group, Type) {
	switch (Group) {
		case 'general':
		if (Type == 'link' && !Entries[ID]['link']) return (0);
		else {
			if (Type == 'directory' && Entries[ID]['type'] != 'directory') return (0);
			else if (Type == 'file' && Entries[ID]['type'] == 'directory') return (0);
			}
		break;
		case 'status':
		if (Type == 'trash' && !Entries[ID]['trash']) return (0);
		else if (Type == 'hidden' && !Entries[ID]['hidden']) return (0);
		else if (Type == 'locked' && !Entries[ID]['locked']) return (0);
		else if (Type == 'broken' && !Entries[ID]['broken']) return (0);
		break;
		case 'type':
		if (Entries[ID]['type'] != Type) return (0);
		break;
		case 'extension':
		if (Entries[ID]['extension'] != Type) return (0);
		break;
		case 'time':
		Time = Date.parse (Entries[ID]['time']);
		if (TimeFrom > -1 && TimeTo > -1 && TimeFrom > Time && TimeTo < Time) return (0);
		else if (TimeFrom > -1 && TimeFrom > Time) return (0);
		else if (TimeTo > -1 && TimeTo < Time) return (0);
		break;
		case 'size':
		if (Entries[ID]['type'] == 'directory') return (0);
		if (SizeFrom > -1 && SizeTo > -1 && SizeFrom > Entries[ID][5] && SizeTo < Entries[ID][5]) return (0);
		else if (SizeFrom > -1 && SizeFrom > Entries[ID][5]) return (0);
		else if (SizeTo > -1 && SizeTo < Entries[ID][5]) return (0);
		break;
		}
	return (1);
	}
function pageFilter () {
	for (ID in Entries) showHide ('entry_' + ID, 1);
	Filter = new Array;
	if (document.getElementById ('filter_timefrom').value != '' && Date.parse (document.getElementById ('filter_timefrom').value)) TimeFrom = Date.parse (document.getElementById ('filter_timefrom').value);
	else TimeFrom = -1;
	if (document.getElementById ('filter_timeto').value != '' && Date.parse(document.getElementById ('filter_timeto').value)) TimeTo = Date.parse (document.getElementById ('filter_timeto').value);
	else TimeTo = -1;
	if (TimeFrom != -1 || TimeTo != -1) Filter[Filter.length] = ['size', 0];
	if (document.getElementById ('filter_sizefrom').value.length && Number (document.getElementById ('filter_sizefrom').value)) SizeFrom = Number (document.getElementById ('filter_sizefrom').value);
	else SizeFrom = -1;
	if (document.getElementById ('filter_sizeto').value.length && Number (document.getElementById ('filter_sizeto').value)) SizeTo = Number (document.getElementById ('filter_sizeto').value);
	else SizeTo = -1;
	if (SizeFrom != -1 || SizeTo != -1) Filter[Filter.length] = ['time', 0];
	Inputs = document.getElementById ('window_filter').getElementsByTagName ('input');
	for (i = 0; i < Inputs.length; i++) {
		if (Inputs[i].type != 'checkbox' || Inputs[i].checked) continue;
		String = Inputs[i].id.substr (Inputs[i].id.indexOf ('_') + 1);
		Filter[Filter.length] = [String.substr (0, String.indexOf ('_')), (String.substr (String.indexOf ('_') + 1))];
		}
	for (ID in Entries) {
		Display = 1;
		for (i = 0; i < Filter.length; i++) {
			if (pageFilterGroup (ID, Filter[i][0], Filter[i][1])) {
				Display = 0;
				break;
				}
			}
		showHide ('entry_' + ID, Display);
		}
	}
function navigationBar () {
	Mode = (document.getElementById ('locationnavigate').style.display == 'none');
	showHide ('locationedit', !Mode);
	showHide ('locationnavigate', Mode);
	cookieSet ('eBrowserNavigationBarEdit', !Mode);
	}
function ratingWidget (ID, Mark) {
	for (i = 1; i < 6; i++) document.getElementById (ID + '_' + i).style.opacity = ((Mark >= i)?1:0.3);
	}
function emoticon (ID, String) {
	document.getElementById (ID).value += String;
	document.getElementById (ID).focus ();
	}
function bbcode (ID, String) {
	if (document.getElementById ('BBC_' + String).value == String) {
		document.getElementById ('BBC_' + String).value = String + '*';
		emoticon (ID, '[' + String + ']');
		}
	else {
		document.getElementById ('BBC_' + String).value = String;
		emoticon (ID, '[/' + String + ']');
		}
	}